#ifndef BASE_H
#define BASE_H

#include "GLfunctions.h"
#include "MapObject.h"

// how large is each base is represented
#define BASE_SIZE_DIVISOR 10.0

class Base : public MapObject {

public:
	Base(const std::string& name,unsigned int playerID);
	~Base();

	Base* clone() const;
	
	bool withinRange(Group* otherObject,const std::string& unitType);
	bool withinRange(Group* otherObject);
	bool takeDamage(const double& damage,const std::string& unitType);
	bool eliminateDead();
	
	void draw();
	void drawInSelectionMode();
	
	double getHitPoints() const;
	unsigned int getVictoryValue() const;
	
	void setHitPoints(double hitPoints);
	void setVictoryValue(unsigned int victoryValue);
	void recalculateExtents();
	
	double getExtents() const;
	
	std::string toString();

private:
	double hitPoints;
	unsigned int victoryValue;

	double extents;
};

#endif
