#include "MapObject.h"

unsigned int MapObject::numObjects = 0;

MapObject::MapObject(const std::string& name,unsigned int playerID){
	this->name = name;
	this->position = Vector3D(0.0,0.0,0.0);
	this->playerID = playerID;
	this->wasHit = false;
	objectID = numObjects++;

	// for now, friendly objects are green, enemy are red
	if(playerID == 0){
		color = Color(0.0,1.0,0.0,1.0);
	}else{
		color = Color(1.0,0.0,0.0,1.0);
	}
}

MapObject::~MapObject(){

}
/*
MapObject::MapObject(const MapObject& b){
	name = b.name;
	position = b.position;
	playerID = b.playerID;
	wasHit = b.wasHit;
	objectID = numObjects++;

	color = b.getColor();
}

MapObject& MapObject::operator=(const MapObject& b){
	if (this == &b) return *this;
	
	this->name = b.name;
	this->position = b.position;
	this->wasHit = b.wasHit;
	this->playerID = b.playerID;
	this->objectID = numObjects++;
	this->color = b.getColor();
	
	return *this;
}
*/
// here we add two more names to the object when we are selecting it, first the ID of the player that owns it,
// and then the actual object ID
void MapObject::drawInSelectionMode(){
	glPushName(playerID);
	glPushName(objectID);
	
	draw();
	
	glPopName();
	glPopName();
}

std::string MapObject::toString(){
	std::ostringstream objectStream;
	
	objectStream << name << "\n";
	objectStream << "position " << position.x << " " << position.y << " \n";
	
	return objectStream.str();
}

std::string MapObject::getName() const{
	return name;
}

Vector3D MapObject::getPosition() const{
	return position;
}

void MapObject::setPosition(const Vector3D& position){
	this->position = position;
}

Color MapObject::getColor() const{
	return color;
}

unsigned int MapObject::getID() const{
	return objectID;
}


