#ifndef UTIL_FUNCTIONS_H
#define UTIL_FUNCTIONS_H

#include <sstream>
#include <string>
#include <iostream>

#include "Defaults.h"

class Unit;
class Player;

template<typename T>
inline std::string convertToString(const T& var) {
	std::ostringstream stream;
	stream << var;
	return stream.str();
}

inline void print(const std::string& string){
	if(debug){
		std::cerr << string << std::endl;
	}
}

inline void printToScreen(const std::string& string){
	print(string);
	
	if(statusBuffer.size() >= statusBufferSize){
		statusBuffer.erase(statusBuffer.begin());
	}
	statusBuffer.push_back(string);
}

Unit* getUnit(const std::string& name);

bool unitExists(const std::string& name);

Player* getPlayer(const unsigned int& playerID);

bool playerExists(const unsigned int& playerID);
void createNewPlayer(const unsigned int& playerID);

void addGroup(std::ifstream& in,const std::string& groupName,const unsigned int& playerID,unsigned int& lineNumber);
void addBase(std::ifstream& in,const std::string& baseName,const unsigned int& playerID, unsigned int& lineNumber);

void readUnitFile(const std::string& unitFile);
void readGroupFile(const std::string& groupFile);
void saveGroupFile(const std::string& saveGroupFile);
void readConfigFile(const std::string& configFile);


#endif


