#ifndef PolyGraph_H
#define PolyGraph_H

// $Id: PolyGraph.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

//#include"Decomp.H"

#if 0

class Point2i
{
public:
  sint4 x,y;
  Point2i() { x = y = 0; }
  Point2i(sint4 a,sint4 b) { x = a, y = b;}

  bool operator==(const Point2i &other) {

    if (x == other.x && y == other.y) {
      return true;
    }
    return false;
  }

  void operator=(const Point2i &other) {
    x = other.x;
    y = other.y;
  }
  bool operator!=(const Point2i &other) {
    if(x!=other.x) return true;
    if(y!=other.y) return true;
    return false;
  }

  double distance(const Point2i &other) {
    real4 x_ = x - other.x;
    real4 y_ = y - other.y;

    return sqrt(x_*x_+y_*y_);
  }
};


class Graph_node
{
public:
  Point2i p;
  Decomp::Node *n1;
  Decomp::Node *n2;
  Vector<struct Graph_node*> neighbours;

  int index;
    
  Graph_node() { n1 = n2 = 0; }
    
  Graph_node(Point2i pp):p(pp) {}
    
  ~Graph_node() {}
    
  bool has_neighbour(Graph_node* n) {
    FORALL (neighbours, it) if (*it == n) return true;
    return false;
  }
};



class PolyGraph
{
public:

  int count;
    
  Vector<Graph_node*> all_nodes;

  PolyGraph():count(0) {}
  ~PolyGraph();

  void build_graph(Decomp*);

  int insert_node(Point2i, Decomp::Node*);

  void delete_last_two_nodes();

  void delete_last_three_nodes();
    
  void clear_graph();

  void build_graph_redundant(Decomp*);
    
  void print_graph();

  Point2i get_point(Point2i, Point2i, Point2i, Point2i);

  void get_points(Point2i p1, Point2i p2, Point2i p3, Point2i p4, Vector<Point2i> &results);
    
  Graph_node* get_node(Decomp::Node*, Decomp::Node*);
    
  bool get_nodes(Decomp::Node *n, Decomp::Node *neighbour, Vector<Graph_node*> &nodes);
};

#endif

#endif
