// $Id: Mapgen.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro

#include "Global.H"

class Tile;
template <typename T> class Map;

class Mapgen
{
public:

    /**
     * initialize the given map.
     * right now this just sets all the tiles to ground tiles.
     * */
  void init_map(Map<Tile> &map_data);

    /**
     * Generates a number of random unreachable platues
     * @param map_data data structure to store the results to
     * @param min_size minimum size of a random platue
     * @param max_size maximum size of a random platue
     * @param num number of platues to generate
     * @param d the center offset is handicaped by random%(offset*d)
     * */
  void generate_obstacle_map(Map<Tile> &map_data, sint4 min_size, sint4 max_size, sint4 num, double d);

   /**
     * Generates the given number of base camps of the given size.
     * places players on the largest disk that fits in the give 
     * map.
     * */
  void generate_basecamp_map(Map<Tile> &map_data, std::stringstream &objects,
			     sint4 num_players, sint4 size, sint4 margin);

    /**
     * Inserts cliffs and splits tiles properly
     * FIXME: this code should be moved to tile
     * */
  void finalize_map(Map<Tile> &map_data);

private:

};
