/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
using namespace std;
using namespace Protocol;
    
const QString WINDOWS_REGISTRY = "/QtExamples";
const QString APP_KEY = "/CreateGame/";

void CreateGame::init(){
    
    m_gamename = "";
    m_gamepass = "";
    m_numplayers = 0;
    m_anony = false;
    m_invisible = false;
    m_anonyname = "";
    m_options = "";
    m_anonyfields = false;
    this->setMinimumSize(this->width(),this->height());
    loadSettings();
    
    
}

void CreateGame::processCreateInfo()
{
    REM("[---- Create processCreateInfo ----]");
    string name = gameNameLineEdit->text();
    string pass  = gamePassLineEdit->text();
    string alias = anonylineEdit->text();
    
    int numPlayers = nPlayersSpinBox->value();
    bool anony =  anonyCheckBox->isChecked();
    bool passprotected;
    if (name.length()==0){
	//GenericErrorForm *error = new GenericErrorForm();
	//error.showError("Game name cannot be empty");
	return;
    }
    if( pass.length() != 0 ){
	passprotected = true;
	cout << "passprotected == true"<<endl;
    }
    else{ 
	passprotected = false;
	cout << "passprotected == false"<<endl;
    }   
            
    QString qanonyname = "null";
    if( anony && alias.length() != 0 ) qanonyname = anonylineEdit->text();
    bool invisible = InvisibleCheckBox->isChecked();
    string options = optionsLineEdit->text();
    

    string anonyname = qanonyname;
    /////////////////////////////////////////////////////////////////////
    if( anony ) cout << "ortsnetGUI anony: true" << endl;
    else cout << "ortsnetGUI anony: false" << endl;
    string invite = Invite::compose(name, numPlayers, invisible, anony, passprotected, anonyname, pass, options );
    cout << "invite:"<<invite << endl;
    /////////////////////////////////////////////////////////////////////
    ahandler->tellService(Invite::compose(name, numPlayers, invisible, anony, passprotected, anonyname, pass, options ));

    setGameName( name );
    setNumPlayers( numPlayers );
    setAnony( anony );
    setPassProtected( passprotected );
    setAnonyname( anonyname );
    setInvisible( invisible );
    setGamePass( pass );
    setOptions( options );
    
    saveSettings();
}

void CreateGame::setup(Handler *handler)
{
    ahandler = handler;
}

void CreateGame::saveSettings()
{
    REM("[ -- saving settings CreateGame -- ]");
    QSettings settings;
    settings.insertSearchPath( QSettings::Windows, WINDOWS_REGISTRY );
    settings.writeEntry( APP_KEY + "WindowWidth", width() );
    settings.writeEntry( APP_KEY + "WindowHeight", height() );
    settings.writeEntry( APP_KEY + "WindowX", x() );
    settings.writeEntry( APP_KEY + "WindowY", y() );
    
    QString qgamename = getGameName();
    QString qpassword = getGamePass();
    QString qoptions = getOptions();
    QString qanonyname = getAnonyname();
    
    settings.writeEntry( APP_KEY + "GameName", qgamename );
    settings.writeEntry( APP_KEY + "Password", qpassword );
    settings.writeEntry( APP_KEY + "NumPlayers", getNumPlayers() );
    settings.writeEntry( APP_KEY + "Anony", getAnony() );
    settings.writeEntry( APP_KEY + "Invisible", getInvisible() );
    if( qanonyname != "null" ) settings.writeEntry( APP_KEY + "Anonyname", qanonyname );
    settings.writeEntry( APP_KEY + "Options", qoptions );
    
}

void CreateGame::loadSettings()
{
    REM("[ -- loading settings CreateGame -- ]");
    QSettings settings;
    settings.insertSearchPath( QSettings::Windows, WINDOWS_REGISTRY );
    int windowWidth = settings.readNumEntry( APP_KEY + "WindowWidth", 0 );
    int windowHeight = settings.readNumEntry( APP_KEY + "WindowHeight", 0 );
    int windowX = settings.readNumEntry( APP_KEY + "WindowX", 350 );
    int windowY = settings.readNumEntry( APP_KEY + "WindowY", 300 );
    
    resize( windowWidth, windowHeight );
    move( windowX, windowY );
    
    QString qgamename = settings.readEntry( APP_KEY + "GameName", "");
    QString qpassword = settings.readEntry( APP_KEY + "Password", "");
    int numplayers = settings.readNumEntry( APP_KEY + "NumPlayers", 0);
    bool anony = settings.readBoolEntry( APP_KEY + "Anony", FALSE);
    bool invisible = settings.readBoolEntry( APP_KEY + "Invisible", FALSE);
    QString qanonyid = settings.readEntry(APP_KEY + "Anonyname", "");
    bool passProtected = settings.readBoolEntry( APP_KEY + "PassProtected", FALSE);
    passProtected = 1; // TODO: do something with passProtected, for now shut up compiler warning
    QString qoptions = settings.readEntry( APP_KEY + "Options", "");
    
        
    gameNameLineEdit->setText( qgamename );
    gamePassLineEdit->setText( qpassword );
    nPlayersSpinBox->setValue( numplayers );
    if( anony ){
	anonyCheckBox->setChecked( anony );
	if( qanonyid != "null" ) anonylineEdit->setText( qanonyid );
    }
    if( invisible ) InvisibleCheckBox->setChecked( invisible );
     optionsLineEdit->setText( qoptions );
}

// Mutator methods
void CreateGame::setGameName( string &name ){
    m_gamename = name;
}

void CreateGame::setGamePass( string &pass ){
    m_gamepass = pass;
}

void CreateGame::setNumPlayers( int numPlayers ){
    m_numplayers = numPlayers;
}

void CreateGame::setAnony( bool anony ){
    
    m_anony = anony;
}

void CreateGame::setInvisible( bool invisible ){
    
    m_invisible = invisible;
}


void CreateGame::setPassProtected( bool passprotected )
{
    m_passprotected = passprotected;
}

void CreateGame::setAnonyname( string& anonyname ){
    m_anonyname = anonyname;
}

void CreateGame::setOptions( string &options ){
    m_options = options;
}

// Accessor methods
string CreateGame::getGameName(){
    return m_gamename;
}

string CreateGame::getGamePass(){
    return m_gamepass;
}

int CreateGame::getNumPlayers(){
    return m_numplayers;
}

bool CreateGame::getInvisible(){
    
    return m_invisible;
}

bool CreateGame::getAnony(){
    
    return m_anony;
}

bool CreateGame::getPassProtected()
{
    return m_passprotected;
}

string CreateGame::getAnonyname(){
    
    return m_anonyname;
}



string CreateGame::getOptions(){
    return m_options;
}

/************************************************************************************
  * Enables anonymizing label and linedit
  ***********************************************************************************/
void CreateGame::enableAnonyFields()
{
    
    if(m_anonyfields == false ){
	anonyNameLabel->setEnabled( true );
	anonylineEdit->setEnabled( true );
	m_anonyfields = true;
	
    }else{
	anonyNameLabel->setEnabled( false );
	anonylineEdit->setEnabled( false );
	m_anonyfields = false;
    }
    
}

