// $Id: Net_Worker.H 5693 2007-08-16 22:59:15Z krysta $

// This is an ORTS file (c) Tu Hoang, licensed under the GPL

/*
 * ====================================================================================
 *
 *        Filename:  Net_Worker.H
 *
 *     Description:  Worker class for ORTS
 *
 *         Version:  1.0
 *         Created:  05/25/04 15:22:49 MDT
 *        Revision:  none
 *        Compiler:  gcc
 *
 *          Author:  Tu Hoang
 *
 * ====================================================================================
 */

#ifndef NET_WORKER_H
#define NET_WORKER_H

#include "Server.H"

#include "Net_Message.H"
#include "Net_GGSClient.H"
#include "Global.H"
#include "Net_Protocol.H"
#include "EventHandler.H"
#include "ShutDown.H"

#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>

class Net_Worker : public EventHandler
{

public:
  
  static pid_t popen2(const std::string &shell_cmd, int *p_fd_in, int *p_fd_out);
  static bool system_output(std::string &s, Net_GGSClient *client, std::string servicename);
  // ====================  LIFECYCLE   =========================================

  std::string user_name;
  std::string password;
  std::string servicename;

  Net_Worker(const std::string &world_);
  virtual ~ Net_Worker();

  // ====================  OPERATORS   =========================================
  sint4 run();
  // ====================  OPERATIONS  =========================================

  //message (KM07)
  static const sint4 FROM ;
  static const sint4 READY_MSG;   // sent when game loop starts
  static const sint4 STEP_MSG;    // sent after views are sent
  
protected:

  std::string world;
  //  GUI *gui;

  Net_GGSClient * client; 

  /**
     skips all messages until the expected message is received. For a maximum
     of maxSpin messages
   */
  bool waitForResponse(Message_Base& expected);
//static bool handle_event(const Event&, Net_GGSClient *client, std::string servicename); //fixme remove
  bool handle_event(const Event&);
};      // ----------  end of class  Net_Worker  ----------

#endif
