// $Id: NUS_Base.cpp,v 1.1 2006/08/10 17:16:01 nicholas Exp $


#include "NUS_Group.h"
#include "NUS_MapObject.h"

#include "NUS_Base.h"

#include <math.h>

namespace NUS_Simul{
	Base::Base(GameObj* obj, uint4 playerID, uint4 hp) : MapObject(playerID){
		hitPoints = hp;
		gameObj = obj;
	}

	Base::Base(GameObj* obj, uint4 playerID) : MapObject(playerID) {
		hitPoints = obj->get_int("hp");
		gameObj = obj;
		
		Vector3D loc(obj->get_int("x"), obj->get_int("y"), 0.0);
		setPosition(loc);
		
		// FIXME: simply assumes width==height
		extents = obj->get_int("height");
	}

	Base* Base::clone() const {
		return new Base(*this);
	}

	bool Base::withinRange(Group* otherObject){
		Vector3D test = otherObject->getPosition();

		if(test.x < (position.x - extents/2.0)) test.x = position.x - extents/2.0;

		if(test.x > (position.x + extents/2.0)) test.x = position.x + extents/2.0;

		if(test.y < (position.y - extents/2.0)) test.y = position.y - extents/2.0;

		if(test.y > (position.y + extents/2.0)) test.y = position.y + extents/2.0;

		double range =  otherObject->getMaxAttackRange();
		if((otherObject->getPosition() - test).length() < range){
			return true;
		}else{
			return false;
		}
	}


}

