// $Id: NUS_Order.cpp,v 1.1 2006/08/10 17:16:01 nicholas Exp $

#include "NUS_Order.h"

namespace NUS_Simul{

  Order::Order(const WayPointVector& wayPoints,
	      real8 speed)
  {
    this->actionType = actionType;
    this->wayPoints = wayPoints;
    this->speed = speed;
    this->orderTimeElapsed = 0.0;
    completed = false;
	executed = false;
	targetBase = NULL;
	targetUnit = NULL;
	targetGroup = NULL;
  }

  Order::Order(const Order& b)
  {
    actionType = b.actionType;
    wayPoints = b.wayPoints;
    speed =b.speed;
    orderTimeElapsed = b.orderTimeElapsed;
    completed = b.completed;
	executed = b.executed;
  }

  Order* Order::clone() const
  {
    return new Order(*this);
  }

  void Order::goToNextWayPoint(){
    if(wayPoints.empty()) ERR("should not be doing this if there are no more waypoints");

    //wayPoints.pop_back();
	wayPoints.erase(wayPoints.begin());
	
   if(wayPoints.empty()){
      completed = true;
    }
  }

}
