#ifndef PWIDGET_H
#define PWIDGET_H

// $Id: PWidget.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "CWidget.H"
#include "Decomp.H"
#include "PolyGraph.H"
#include "PathProcessor.H"


struct Line_Segment {
  sint4 x1, y1, x2, y2; 
};

typedef struct Line_Segment Segment2i;

class PWidget : public CWidget
{
  Vector<Segment2i> lines;
  sint4 world_width, world_height;
  SectorDecomp *curDecomp;
  PolyGraph *graph;
  const PathProcessor *pp;
    
public:
  
  //vector<Decomp::Rect> tunnel;
  
  sint4 displacement;
  
  bool display_segments;
  bool display_corridors;
  bool display_obstacles;
  bool display_decomposition;
  bool display_graph;
  bool display_path;
  
  Decomp::Node *source;
  Decomp::Node *target;
  
  
  PWidget() {
    world_width = world_height = 0;
    curDecomp = 0;
    graph = 0;

    display_segments = true;
    display_decomposition = false;
    display_graph = false;
    display_path = true;

    display_corridors = false;
    display_obstacles = false;
    
    source = 0;
    target = 0;

    pp = 0;
  }

  void init_world(sint4 w,sint4 h);
  void empty_lines();
  void insert_line(Segment2i);

  void set_decomposition(SectorDecomp*);
  void set_graph(PolyGraph*);
  void set_paths(const PathProcessor*);
  //void set_tunnel(const vector<Decomp::Node*>&);
  
  void draw_path(const Vector<Point2i> &);
  void draw_line(Point2i, Point2i);

protected:
  virtual stype event_key_down(stype key, stype mod, stype x, stype y);
  virtual stype draw();

};

#endif
