#ifndef GAIEventHandler_H
#define GAIEventHandler_H

// $Id: GAIEventHandler.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "EventHandler.H"
#include "Random.H"
#include "GAISquad.H"

class GameStateModule;
class GfxModule;


// This class gives the event handler access to all game and gfx data

struct GAIState {

  GameStateModule *gsm;
  GfxModule       *gfxm; // !=0 : gfx used
  bool just_drew;  // just drew a gfx frame
  bool quit;       // true => quit game
  bool error;      // true <=> error occurred
  
  GAIState(GameStateModule *gsm_, GfxModule *gfxm_) :
    gsm(gsm_), gfxm(gfxm_)
  {
    just_drew = quit = error = false;
  }

};


// This class handles server events
// In particular it generates game object actions

class GAIEventHandler : public EventHandler {

public:
  
  GAIState &state;

  GAIEventHandler(GAIState &state_, sint4 seed) : state(state_) {
    rand.srand(seed);
  }
  
  bool handle_event(const Event &e);

private:
  
  void compute_actions();
  ScalarPoint getTileCoor(ScalarPoint x);
  Random rand; // local RNG
  GAITank** baseTanks1;
  GAITank** baseTanks2;
  GAITank** baseTanks3;
  GAITank** baseTanks4;
  GAITank** baseTanks5;
  
};

#endif
