// $Id $
//Kai:
// Triangulation Overlay Implementation
#include "TR_TerrainOverlay.H"
#include "ST_PFEngine.H"
#include "GfxModule.H"
#include "GfxGlobal.H"
#include "Profiler.H"

#include "Game.H"


//Kai: added for class TraDcdt
#include "Base.h"

using namespace std;
using boost::shared_ptr;

namespace TRTerrain {

//===================================================================

	TRTerrainOverlay::TRTerrainOverlay( TraDcdt** pfDcdt, GfxModule &gfxm_, GameStateModule &gsm_)
	: dot(gfxm_), gfxm(&gfxm_),gsm(&gsm_),tradcdt(pfDcdt)
{
  enabled = false;
  //terrain_p = &terrain;
}


//-------------------------------------------------------------------

bool TRTerrainOverlay::handle_event(const Event &e)
{
  if (e.get_who() == GfxModule::FROM) {
    if (e.get_what() == GfxModule::DRAW_MSG) {
      draw();
      return true;
    }
  }
  return false;
}

void TRTerrainOverlay::draw()
{
	
	PROFILE("TRTerrainOverlay");
	//shared_ptr<const TRTerrain::PFEngine::Map> map;
	//map =  terrain_p->pfEngine->get_ground_map();
	
	//TraDcdt* tradcdt = terrain_p->getPFDcdt();

	int polyNum = (*tradcdt)->num_polygons();
	
	if(polyNum >0 )
	{
	
		SrArray<SrPnt2> constr ;
		SrArray<SrPnt2> unconstr ;
		(*tradcdt)->get_mesh_edges(&constr,&unconstr);
		
		
		PROFILE("draw lines");
		if (true)
		{
		
			Vec3<real4> color(1,1,1);
			dot.begin_lines();
		
		
			real4 x1, y1 , x2 , y2;
			//sint4 size1= constr.size();
			sint4 tilepionts = gsm->get_game().get_tile_points();
			
			for(int i=0; i<constr.size()-2;i= i+2 )
			{
				SrPnt2 p1 = constr[i];
				SrPnt2 p2 = constr[i+1];
				x1 = p1.x /tilepionts;
				y1 = p1.y /tilepionts;
				x2 = p2.x /tilepionts;
				y2 = p2.y /tilepionts;
				
				dot.draw_line(x1, y1, x2, y2, color, 1.0);
			}
			
			
				
			
				
			
			dot.end_lines();
			
			
			Vec3<real4> color2(0,1,0);
			dot.begin_lines();
					
			
			for(int i=0; i<unconstr.size()-2;i= i+2 )
			{
				SrPnt2 p1 = unconstr[i];
				SrPnt2 p2 = unconstr[i+1];
				x1 = p1.x /tilepionts;
				y1 = p1.y /tilepionts;
				x2 = p2.x /tilepionts;
				y2 = p2.y /tilepionts;
				
				dot.draw_line(x1, y1, x2, y2, color2, 1.0);
			}
			
			
				
			
				
			
			dot.end_lines();
		}
		
	}
	
	
#if 0
	if(polyNum >0 )
	{
	
		SrArray<SrPnt2> constr ;
		SrArray<SrPnt2> unconstr ;
		tradcdt->get_mesh_edges(&constr,&unconstr);
		
		
		PROFILE("draw lines");
		if (terrain_p)
		{
		
			Vec3<real4> color(1,1,1);
			dot.begin_lines();
		
		
			real4 x1, y1 , x2 , y2;
			//sint4 size1= constr.size();
			sint4 tilepionts = gsm->get_game().get_tile_points();
			
			for(int i=0; i<constr.size()-1;i++ )
			{
				SrPnt2 p1 = constr[i];
				SrPnt2 p2 = constr[i+1];
				x1 = p1.x /tilepionts;
				y1 = p1.y /tilepionts;
				x2 = p2.x /tilepionts;
				y2 = p2.y /tilepionts;
				
				dot.draw_line(x1, y1, x2, y2, color, 1.0);
			}
			
			
				
			
				
			
			dot.end_lines();
		}
		
	}
#endif

}

//-------------------------------------------------------------------
/*
void TRTerrainOverlay::draw()
{
  PROFILE("TerrainOverlay");

  if (!enabled) return;

  bool draw_air = false;

  shared_ptr<const ST_Terrain::PFEngine::Map> map;
  if (forcefield_p){
    if (!forcefield_p->pfEngine) return;
    map = draw_air ? forcefield_p->pfEngine->get_air_map() : forcefield_p->pfEngine->get_ground_map();
  }
  else{
    if (!terrain_p->pfEngine) return;
    map =  draw_air ? terrain_p->pfEngine->get_air_map() : terrain_p->pfEngine->get_ground_map();
  }
    
  
  //if (!st_terrain->pfEngine) return;

  //shared_ptr<const ST_Terrain::PFEngine::Map> map = draw_air ? st_terrain->pfEngine->get_air_map() : st_terrain->pfEngine->get_ground_map();

  sint4 map_width = map->get_w();
  sint4 map_height = map->get_h();
  
  sint4 gw = gfxm->get_game().get_map().get_width();
  sint4 gh = gfxm->get_game().get_map().get_height();

  real4 dx = (real4)gw / (real4)(map_width-1);
  real4 dy = (real4)gh / (real4)(map_height-1);

  {
    PROFILE("draw tiles");
#if 1
    dot.begin_squares();
    FORS (xi, map_width) {
      FORS (yi, map_height) {
        if ((*map)(xi, yi).max_size > 0 || (*map)(xi, yi).cost != 0 ) {
          
          Vec3<real4> c;
          real4 v = (*map)(xi, yi).max_size / 20.0;
          c = Vec3<real4>(v, 0, 0);
            //          if ((*map)(xi, yi).max_size < 1) c = Vec3<real4>(1, 0, 0);
            //          if ((*map)(xi, yi).cost > 0)     c = Vec3<real4>(0, 1, 1);

          real4 x1 = (xi-0.5) * dx;
          real4 x2 = (xi+0.5) * dx;
          real4 y1 = (yi-0.5) * dy;
          real4 y2 = (yi+0.5) * dy;
          
          dot.draw_square(x1, y1, x2, y2, c);
        }
      }
    }
    dot.end_squares();
#endif
  }
  
  {
    PROFILE("draw lines");
    if (terrain_p){     
      const std::list<ST_Task> &tasks = terrain_p->tasks;

      Vec3<real4> c(1,1,1);

      dot.begin_lines();
      FORALL (tasks, j) {
	if (!j->path) continue;
	const UnitPath &upath = *j->path;
	const Vector<Loc> &path = upath.path;
      
	real4 x1, y1;
	if (path.size() > 1) {
	  x1 = map->world2x(path[0].x);
	  y1 = map->world2y(path[0].y);
	  x1 *= dx;
	  y1 *= dy;

	  for (uint4 i = 1; i < path.size(); ++i) {
	    real4 x2 = map->world2x(path[i].x);
	    real4 y2 = map->world2y(path[i].y);
	    x2 *= dx;
	    y2 *= dy;
          
	    dot.draw_line(x1, y1, x2, y2, c, 1.0);
          
	    x1 = x2;
	    y1 = y2;
	  }
	}
      }
    
      dot.end_lines();
    }
    else{
      const std::list<FF_Task> &tasks = forcefield_p->tasks;

      Vec3<real4> c(1,1,1);

      dot.begin_lines();
      FORALL (tasks, j) {
	if (!j->path) continue;
	const UnitPath_FF &upath = *j->path;
	const Vector<Loc> &path = upath.path;
      
	real4 x1, y1;
	if (path.size() > 1) {
	  x1 = map->world2x(path[0].x);
	  y1 = map->world2y(path[0].y);
	  x1 *= dx;
	  y1 *= dy;

	  for (uint4 i = 1; i < path.size(); ++i) {
	    real4 x2 = map->world2x(path[i].x);
	    real4 y2 = map->world2y(path[i].y);
	    x2 *= dx;
	    y2 *= dy;
          
	    dot.draw_line(x1, y1, x2, y2, c, 1.0);
          
	    x1 = x2;
	    y1 = y2;
	  }
	}
      }
    
      dot.end_lines();
    }
  }
    
  glEnable(GL_TEXTURE_2D);
}*/



//===================================================================

#if 0
  void SimpleTerrainWidget::set_env(Environment* env_){
    env = env_;
    wwidth = map->get_w();
    wheight = map->get_h();
  }
#endif

//===================================================================

}
