#ifndef TR_TerrainOverlay_H
#define TR_TerrainOverlay_H

// $Id $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
//#include "CGridBase.H"
#include "TRTerrain.H"
#include "ST_ForceField.H"
#include "ST_SimpleMap.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"

#include "GameStateModule.H"

class GfxModule;

//===================================================================

namespace TRTerrain {

  class TRTerrainOverlay : public EventHandler {
  private:
    
	  TraDcdt** tradcdt;
    //const ST_ForceField *forcefield_p;
    DrawOnTerrain dot;
    bool enabled;

    GfxModule *gfxm;
    
    GameStateModule *gsm;

  public:
	  TRTerrainOverlay(TraDcdt** pfDcdt, GfxModule &gfxm,GameStateModule &gsm);
    //TRTerrainOverlay(const ST_ForceField &terrain, GfxModule &gfxm);

    bool is_enabled() const { return enabled; }
    void enable() { enabled = true; }
    void disable() { enabled = false; }
    void draw();

    bool handle_event(const Event &e);
  };

  //-----------------------------------------------------------------
#if 0
  class SimpleTerrainWidget : public CGridBase
  {
  private:

    sint4 wwidth;
    sint4 wheight;

    bool draw_tiles;
    bool draw_air;

    const ST_Terrain *terrain_p;
    const ST_ForceField *forcefield_p;
    SimpleTerrainOverlay *overlay;

  public:

    SimpleTerrainWidget(const ST_Terrain &terrain, GfxModule *gfxm=0);
    SimpleTerrainWidget(const ST_ForceField &terrain, GfxModule *gfxm=0);
    ~SimpleTerrainWidget();

    virtual stype event_key_down(stype key, stype mod, stype x, stype y);
    virtual stype draw();
  };

#endif

}

//===================================================================

#endif
