#ifndef TR_EventHandler_H
#define TR_EventHandler_H

// $Id: TR_EventHandler.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Game.H"
#include "GameStateModule.H"
#include "EventHandler.H"
#include "TRTerrain.H"
#include "Random.H"

using namespace std;

class GameStateModule;
class GfxModule;


// This class gives the event handler access to all game and gfx data

struct SampleAIState {

  GameStateModule *gsm;
  GfxModule       *gfxm; // !=0 : gfx used
  bool just_drew;  // just drew a gfx frame
  bool quit;       // true => quit game
  bool error;      // true <=> error occurred
  
  SampleAIState(GameStateModule *gsm_, GfxModule *gfxm_) :
    gsm(gsm_), gfxm(gfxm_)
  {
    just_drew = quit = error = false;
  }

};


// This class handles server events
// In particular it generates game object actions

class TR_EventHandler : public EventHandler {

public:
  
  SampleAIState &state;
//DJD: instance of the terrain class {
TRTerrain::TR_Terrain terrain;
//instance of the terrain class }

  TR_EventHandler(SampleAIState &state_, sint4 seed) : state(state_) {
    rand.srand(seed);
  }

  bool handle_event(const Event &e);

private:
  
  void compute_actions();
  Random rand; // local RNG
  
};

#endif
