#ifndef Worlded_H
#define Worlded_H

/** @file Worlded.H
   $Id: Worlded.H 5279 2007-06-23 02:49:08Z mburo $
    $Source$
*/

#include "Global.H"
#include "../../../libs/serverclient/src/MapTool.H"

class Worlded
{
public:

  struct Unit {
    std::string name;
    sint4 x;
    sint4 y;
  };
  
  // Call this function if you want to access the worlded object
  static Worlded* instance();
  
  // Call this to set all the member variables at once 
  void initialize(sint4 tile_height, sint4 radius, Tile::Type t);

  // Returns false until the first time initialize is called
  static bool isInitialized();

  //change tiles around x, y to tile type and increment height by diff
  void change_tiles(sint4 x, sint4 y);
  void place_unit(std::string name, sint4 x, sint4 y);
  //returns worst ratio of n player scores
  Tile::Type get_type();
  void set_tile(Tile::Type t);
  Map<Tile>* get_map();
  void set_map(Map<Tile>* m);
  void set_height(sint4 h);
  sint4 get_height();
  void set_radius(sint4 r);
  sint4 get_radius();
  void set_units(Vector<Unit>* u);
  Vector<Unit>* get_units();
  void generate_map();
  real4 get_worst(int* player_score, int n);
  static void add_options();
 
private:

  // Enforce Singleton by making these private
    Worlded(){}
  
  Worlded(const Worlded& w);
  const Worlded& operator=(const Worlded& w);

  // The single instance of the worlded class
  static Worlded *worldedInstance;
  
  // If initialize has not been called this is false 
  static bool initialized; 

  Map<Tile> *map_data;
  Vector<Unit> *units;
  sint4 tile_height;
  sint4 radius; //brush radius
  Tile::Type tile_type;
   Random rand;
};


#endif
