#!/bin/sh
#
# You should run this as root or in sudo. 

echo "Installing dependencies via YUM". 

yum install gcc gcc-headers glibc glibc-headers libstdc++ libstdc++-devel \
            boost boost-devel make \
            SDL SDL-devel SDL_net SDL_net-devel \
            freeglut freeglut-devel \
            zlib zlib-devel \
            gawk

if [ "$?" != "0" ]
then
	echo "yum failed. You may not be root, or you may not have yum setup properly."
	echo "You may have to download some packages and install them separately."
	exit
fi

echo "Installing glew"

wget ftp://ftp.pbone.net/mirror/newrpms.sunsite.dk/projects/newrpms/www/htdocs/apt/redhat/en/i386/fc4/RPMS.newrpms/glew-1.3.3-1.rhfc4.nr.i386.rpm && rpm -Uvh glew-1.3.3-1.rhfc4.nr.i386.rpm 

if [ "$?" != "0" ]
then
	echo "wget or rpm failed. Please download the latest Fedora Core glew RPM from http://rpm.pbone.net"
	echo "and manually install it using rpm -Uvh glew-blabla.rpm"
	exit
fi

echo "Installing glew-devel"

wget ftp://ftp.pbone.net/mirror/newrpms.sunsite.dk/projects/newrpms/www/htdocs/apt/redhat/en/i386/fc4/RPMS.newrpms/glew-devel-1.3.3-1.rhfc4.nr.i386.rpm && rpm -Uvh glew-devel-1.3.3-1.rhfc4.nr.i386.rpm

if [ "$?" != "0" ]
then
	echo "wget or rpm failed. Please download the latest Fedora Core glew-devel RPM from http://rpm.pbone.net"
	echo "and manually install it using rpm -Uvh glew-blabla.rpm"
	exit
fi

