// $Id: SI_Order.cpp 4182 2007-04-05 21:13:47Z kalf $

#include "SI_Order.h"

namespace Simul{

  Order::Order(const WayPointVector& wayPoints,
	      real8 speed)
  {
    this->actionType = actionType;
    this->wayPoints = wayPoints;
    this->speed = speed;
    this->orderTimeElapsed = 0.0;
    completed = false;
  }

  Order::Order(const Order& b)
  {
    actionType = b.actionType;
    wayPoints = b.wayPoints;
    speed =b.speed;
    orderTimeElapsed = b.orderTimeElapsed;
    completed = b.completed;
  }

  Order* Order::clone() const
  {
    return new Order(*this);
  }

  void Order::goToNextWayPoint(){
    if(wayPoints.empty()) ERR("should not be doing this if there are no mroe waypoints");

    wayPoints.pop_back();
    if(wayPoints.empty()){
      completed = true;
    }
  }

}
