#ifndef SI_ORDER_H
#define SI_ORDER_H

// $Id: SI_Order.h 4182 2007-04-05 21:13:47Z kalf $

#include "Global.H"
#include "Vector.H"

#include "SI_Vector3D.h"
#include <string>


namespace Simul{

  typedef Vector<Vector3D> WayPointVector;

  class Order
  {
  public:
    Order(const WayPointVector& wayPoints,real8 speed);

    Order(const Order& b);

    Order* clone() const;

    WayPointVector getWayPoints() const { return wayPoints;}
    real8 getSpeed() const { return speed;}
    real8 getOrderTimeElapsed() const {return orderTimeElapsed;}

    void setActionType(const std::string& actionType) { this->actionType = actionType;}
    void setOrderTimeElapsed(real8 time) {this->orderTimeElapsed = time;}

    std::string getActionType() const {return actionType;}

    void setCompleted(bool completed) {this->completed = completed;}
    bool isCompleted() const {return completed;}

    Vector3D getDestination(){
      if(wayPoints.empty()) ERR("trying to get destination of finished order!");

      return wayPoints.back();
    }

    void goToNextWayPoint();

  protected:
    WayPointVector wayPoints;

    real8 speed; // the speed at which this unit travels

    std::string actionType;

    real8 orderTimeElapsed;
    bool completed;

  private:
    Order& operator=(const Order& b);
  };
}

#endif
