#include "ModuleSet.H"
#include <assert.h>

ModuleSet::ModuleSet() :
    fm(0), gsm(0), hm(0), scai(0), 
    tam(0), wm(0)
{

}

ModuleSet::~ModuleSet()
{

}

void ModuleSet::set_game_state(GameStateModule * gsm)
{
    this->gsm = gsm;
}

void ModuleSet::set_combat(SquadCombatAI * scai)
{
    this->scai = scai;
}

void ModuleSet::set_watcher(Watcher::WatcherModule * wm)
{
    this->wm = wm;
}

void ModuleSet::set_history(History::HistoryModule * hm)
{
    this->hm = hm;
}

void ModuleSet::set_terrain_analysis(TerrainAnalysis::Module * tam)
{
    this->tam = tam;
}

void ModuleSet::set_finance(Finance::Module * fm)
{
    this->fm = fm;
}

void ModuleSet::set_movement(boost::shared_ptr<Movement::Module> mm)
{
    this->mm = mm;
}

GameStateModule & ModuleSet::get_game_state() const
{
    assert(gsm);
    return *gsm;
}

SquadCombatAI & ModuleSet::get_combat() const
{
    assert(scai);
    return *scai;
}

Watcher::WatcherModule & ModuleSet::get_watcher() const
{
    assert(wm);
    return *wm;
}

History::HistoryModule & ModuleSet::get_history() const
{
    assert(hm);
    return *hm;
}

TerrainAnalysis::Module & ModuleSet::get_terrain_analysis() const
{
    assert(tam);
    return *tam;
}

Finance::Module & ModuleSet::get_finance() const
{
    assert(fm);
    return *fm;
}

Movement::Module & ModuleSet::get_movement() const
{
    assert(mm);
    return *mm;
}
