#ifndef PLAYER_COMMANDER_H
#define PLAYER_COMMANDER_H

#include "Commander.H"
#include "GameStateModule.H"
#include "Movement.H"
#include "PlayerActions.H"

class ScoutCommander;
class GatherCommander;

class PlayerCommander : public Commander, public PlayerActionHandler
{
	GameStateModule &gsm;
	Movement::Context mc;
	sint4 client;
	
	ScoutCommander * scoutComm;
	std::map<GameObj::Ptr, GatherCommander*> cc2comm;
	std::set<Commander*> commanders;
	std::map<GameObj*, Commander*> unit2commander;

	GatherCommander * pickBestGC(GameObj * resource) const;
	bool unitOwnedByPlayer(GameObj * unit) const;
public:
	PlayerCommander(ModuleSet & ms);
	~PlayerCommander();

	// PLAYER COMMANDS
	void stop(GameObj * unit);
	void move(GameObj * unit, sint4 x, sint4 y);
	void attack(GameObj *, GameObj *) {}
	void gather(GameObj * unit, GameObj * target);
	void build(GameObj * unit, const std::string & bp_name, sint4 x, sint4 y);
	
	void scout(GameObj * unit);
	void autoAttack(GameObj * unit);
	// END PLAYER COMMANDS

	// IMPLEMENTATION OF COMMANDER
    void exec() {}
	void onReceiveUnit(GameObj *, Watcher::WatchID) {}
    void onLoseUnit(GameObj *) {}
	bool onEvent(const Event &);
};

#endif
