#ifndef SquadCombatAIWidget_H
#define SquadCombatAIWidget_H

// $Id: SquadCombatAIWidget.H 4347 2007-05-16 23:29:50Z orts_furtak $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "CGridBase.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"
#include "SquadCombatAI.H"

class GfxModule;

//===================================================================

class SquadCombatAIOverlay : public EventHandler {
private:

  const SquadCombatAI *sc;
  
  DrawOnTerrain dot;
  bool enabled;
  bool show_avg_dist;
  bool show_dir;
  bool show_friend_influence;
  bool show_target_influence;

  bool show_motion_field;
  bool show_occupied_field;
  bool color_units;
  
  GfxModule *gfxm;
  
public:
  
  SquadCombatAIOverlay(const SquadCombatAI &scai, GfxModule &gfxm);
  
  bool is_enabled() const { return enabled; }
  void enable() { enabled = true; }
  void disable() { enabled = false; }
  void draw();

  void toggle_avg_dist() { show_avg_dist = !show_avg_dist; }
  void toggle_dir() { show_dir = !show_dir; }
  void toggle_friend_influence() { show_friend_influence = !show_friend_influence; }
  void toggle_target_influence() { show_target_influence = !show_target_influence; }
  void toggle_motion_field() { show_motion_field = !show_motion_field; }
  void toggle_occupied_field() { show_occupied_field = !show_occupied_field; }
  void toggle_color_units() { color_units = !color_units; }
  
  bool handle_event(const Event &e);
};

//-----------------------------------------------------------------

class SquadCombatAIWidget : public CGridBase
{
private:

  SquadCombatAI *sc;
  SquadCombatAIOverlay *overlay;
  
public:
  
  SquadCombatAIWidget(SquadCombatAI &scai, GfxModule *gfxm=0);
  ~SquadCombatAIWidget();
  
  virtual stype event_key_down(stype key, stype mod, stype x, stype y);
  virtual stype draw();
};

//===================================================================

#endif
