// $Id: BuildTasks.cpp 2315 2006-08-10 17:43:00Z nicholas $


#include "BuildTasks.h"

#include "BuildTasksAI.h"
#include "BuildTasksState.h"
#include "Random.H"
#include "GameStateModule.H"
#include "Game.H"
#include "GameChanges.H"
#include "GameObj.H"
#include "GfxModule.H"
#include "TerrainModule.H"

//REMEMBER TO MOVE THE BUILD LOCATION CODE TO THE STATE CLASS AND GENERALIZE
namespace BSimul {

#define DEFINE_BTASK(name)						\
  name::name(uint4 playerID,BuildTasksState* state,ObjectVector& origObjects,	\
	     TaskCreateFunctionPtr f,std::string n,real8 timeout,MoveStruct* extraData) : \
    Task(playerID,state,origObjects,f,n,timeout,extraData){	\
    exec();								\
  }									\
    name::name(Task* parent,ObjectVector& origObjects,TaskCreateFunctionPtr function,std::string n, \
	       real8 timeout,MoveStruct* extraData) :	\
      Task(parent,origObjects,function,n,timeout,extraData){ \
      exec();								\
    }									\
    name::name(const name& t) : Task(t){}				\
    Task* name::clone(BuildTasksState* state,Task* newParent){		\
      name* newTask = new name(*this);					\
      newTask->parent = newParent;					\
      newTask->state = state;						\
      FORALL(children,it){						\
	newTask->children.push_back((*it)->clone(state,newTask));	\
      }									\
      return newTask;							\
    }									\
    bool name::exec()

  /*
  DEFINE_TASK(SpreadAttack) {
    ObjectVector temp;

    switch(lineNum) {
    case 0:
      // need a copy of this vector, since the constructor for tasks modifies the original by removing objects from it
      temp = objects;

      FORALL(temp, it) {
        ObjectVector object;
	object.push_back(*it);

        GameObj* nearestBase = state->getNearestEnemyBaseOfGroup(object);
	if(nearestBase != NULL) {
	  new Attack(this,object,function,name,new MoveStruct(nearestBase));

	}else{

	  if(children.empty()){
	    return true;
	  }else{
  	    ++lineNum;
	    return false;
	  }
	}

      }
      return false;
    default:
      return true;
    }
  }
  */

 //  DEFINE_BTASK(TrainWorkers){
//     switch(lineNum){
//     case 0: {	
   
//       cout << "CREATE WORKER \m"
//       ++lineNum;
//       return false;
//     }
//     default: 
//       return true;
//     }


//   }


//   DEFINE_BTASK(WorkerRush){

//     switch(lineNum){
//     case 0: {					
//       // Send all of our starting workers out to gather minerals.
//       ExtraObjectData newData;
//       newData.isDone=true;
//       FORALL(objects, it){
// 	state->getFriendlyUnits()[(*it)] = newData;
//       }
//       // Create as many workers as we can 
//       new TrainWorkers(this, simulationState, simulationState->getCC(),function, name, 0.0, extraData);
  


//       ++lineNum;
//       return false;
//     }
//     default: 
//       return true;
//     }

//   }

  DEFINE_BTASK(BuildandTrain) {
    fprintf(stdout, "BUILD AND TRAIN\n");
    ObjectVector builder;
    builder.push_back(objects[0]);
    switch(lineNum){
    case 0:{
      fprintf(stdout, "checking etc\n");
      fprintf(stdout, "size of vector: %d\n", builder.size());
      builder[0];
      fprintf(stderr, "that worked\n");
      fprintf(stdout, "hiya\n");
      if(!(builder[0]->get_int("is_mobile"))) return false;
      ExtraObjectData builderData;
      state->getFriendlyUnits()[builder[0]] = builderData;
      //fprintf(stderr, "before removing from auto\n");
      state->autogatherer->removeW(builder);      
      //fprintf(stderr, "after\n");

      new MovetoBuild(this, builder, function, name, 0.0, extraData);
      //new Scout(this, builder, function, name, 0.0, extraData);
      ++lineNum;
      return false;
    }
    case 1:{
      fprintf(stderr, "building\n");
      new BuildBarracks(this, builder, function, name, 0.0, extraData);
      ++lineNum;
      return false;
    }
      //   case 2:{
      //       fprintf(stderr, "scout\n");
      //       new Scout(this, builder, function, name, 0.0, extraData);
      //       ++lineNum;
      //       return false;
      //  }     
    default: 
      return true;
    }
    
  }

  DEFINE_BTASK(MovetoBuild){
    fprintf(stdout, "MOVE TO BUILD\n");
    ObjectVector temp;

    sint4 x, y;
    x=0;
    y=0;
    bool found=false;
    temp=objects;
    GameObj* builder = temp[0];

    builder->get_center(x,y);
    TerrainBase::Loc loc(0,0);
    TerrainBase::Loc start(x,y);
    

    switch(lineNum){
    case 0:{
 
    
      //bool free = terrMap.is_free_of_units(start, 50, 2);
      //  bool random = terrMap.get_random_unexplored_point(start, loc, 30 , 256);
      found = state->terrMap->find_free_loc(start, loc, 256, 3); 

      // std::cout << "free = " << free << "random = " << random << "found = " << found << std::endl;

      //terrMap.print_map();
      fprintf(stderr, "\n");
      if(found){
	//	fprintf(stderr,"x: %d, y: %d\n", x*16, y*16);
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::TOUCH,
                           TerrainBase::Task::INDIVIDUAL);

	state->terrMap->print_map();
	std::cout << "Tile to build : (" << loc.x / 16 << "," << loc.y / 16 << ")" << std::endl;

	task.goal.loc = loc;
	task.objs.insert(builder);
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
        newData.state = ExtraObjectData::BUILD;
	state->getFriendlyUnits()[builder] = newData;
	lineNum++;
	return false;
      }
      else{
	fprintf(stdout, "could not find a location\n");
	//new Scout(this, temp, function, name, 0.0, extraData);
	return false;
      }
    }
    default:
      return true;
    }
  }
  
  DEFINE_BTASK(BuildControlCenter){
    ObjectVector temp;
    temp=objects;
    sint4 x, y;
    GameObj* builder = temp[0];
    switch(lineNum) {
    case 0:{
      builder->get_center(x,y);
      Vector<sint4> args;
      args.push_back(x);
      args.push_back(y);
      builder->set_action("build_controlCenter", args);
      
      ++lineNum;
      return false;
    }
    case 1:{
      builder->get_center(x,y);
      if(builder->get_int("is_mobile")){
	builder->get_center(x,y);
	Vector<sint4> args;
	args.push_back(x);
	args.push_back(y);
	builder->set_action("build_controlCenter", args);
	break;
      }
      state->addNewBuilding(builder);
      ++lineNum;
      return false;
    }
    default:
      return true;
    }
    return false;
  }

  DEFINE_BTASK(BuildBarracks){
    std::cout << "Build barracks" << std::endl; 

    ObjectVector temp;
    temp=objects;
    sint4 x, y;
    GameObj* builder = temp[0];
    static sint4 tries = 0;

    switch(lineNum) {
    case 0:{
      builder->get_center(x,y);
      Vector<sint4> args;
      args.push_back(x);
      args.push_back(y);
      builder->set_action("build_barracks", args);
    
      ++lineNum;
      return false;
    }
    case 1:{
      tries++;
      builder->get_center(x,y);
      if(builder->get_int("is_mobile")){
	builder->get_center(x,y);
	Vector<sint4> args;
	sint4 xprime, yprime;
	if(tries % 2 == 0){
	  xprime = x + (sint4)(state->rand.rand_uint4() % 32);
	  yprime = y + (sint4)(state->rand.rand_uint4() % 32);
	}
	else{
	  xprime = x - (sint4)(state->rand.rand_uint4() % 24);
	  yprime = y - (sint4)(state->rand.rand_uint4() % 24);
	}

	args.push_back(xprime);
	args.push_back(yprime);
	builder->set_action("build_barracks", args);
	break;
      }
      state->addNewBuilding(builder);
      ++lineNum;
      return false;
    }
    default:
      return true;
    }
    return false;
  }

  DEFINE_BTASK(BuildFactory){
    ObjectVector temp;
    temp=objects;
    sint4 x, y;
    GameObj* builder = temp[0];
    switch(lineNum) {
    case 0:{
      builder->get_center(x,y);
      Vector<sint4> args;
      args.push_back(x);
      args.push_back(y);
      builder->set_action("build_factory", args);
    
      ++lineNum;
      return false;
    }
    case 1:{
      builder->get_center(x,y);
      if(builder->get_int("is_mobile")){
	builder->get_center(x,y);
	Vector<sint4> args;
	args.push_back(x);
	args.push_back(y);
	builder->set_action("build_factory", args);
	break;
      }
      state->addNewBuilding(builder);
      ++lineNum;
      return false;
    }
    default:
      return true;
    }
    return false;
  }
  
  DEFINE_BTASK(TrainMarine){
    switch(lineNum) {
    case 0:{
      FORALL(objects, it){
	Vector<sint4> args;
	if((*it)->get_int("task_done")!=0) continue;
	(*it)->set_action("train_marine", args);
	state->getFriendlyUnits()[(*it)].isDone=true; //potential problem spot
	++lineNum;
	return false;
      }
	
      return false;
    }
    default:
      return true;
    }
  }
  
  DEFINE_BTASK(TrainTank){
    switch(lineNum) {
    case 0:{
      FORALL(objects, it){
	Vector<sint4> args;
	if((*it)->get_int("task_done")!=0) continue;
	(*it)->set_action("build_tank", args);
	state->getFriendlyUnits()[(*it)].isDone=true;
	++lineNum;
	return false;
      }
      
      return false;
    }
    default:
      return true;
    }
  }
  
  DEFINE_BTASK(TrainWorker){
    switch(lineNum) {
    case 0:{
      FORALL(objects, it){
	Vector<sint4> args;
	if((*it)->get_int("task_done")!=0) continue;
	(*it)->set_action("train_worker", args);
	state->getFriendlyUnits()[(*it)].isDone=true;
	std::cout << "SET CONTROL CENTER STATUS TO TRAIN WORKER!!" << std::endl;
	++lineNum;
	return false;
      }
      std::cout << "NO CONTROL CENTERS FOUND!!" << std::endl;
      return false;
    }
    default:
      return true;
    }
  }

  DEFINE_BTASK(Scout){
    switch(lineNum){
    case 0:{
      if(state->massAttack){
	lineNum++;
	return true;
      }
	
      sint4 x,y;
      bool found=false;
      
      objects[0]->get_center(x,y);
      TerrainBase::Loc loc(1,1);
      TerrainBase::Loc start(x,y);
      found = state->terrMap->get_random_unexplored_point(start, loc);
      
      if(!found){
	++lineNum;
	return false;
      }

      FORALL(objects, it){
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::TOUCH, 
			       TerrainBase::Task::INDIVIDUAL);    

	state->terrMap->print_map();
	std::cout << "Going to (" << loc.x/16 << "," << loc.y/16 << ")" <<  std::endl;

	task.goal.loc = loc;
	task.objs.insert(*it);
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
	newData.state = ExtraObjectData::SCOUT;
	state->getFriendlyUnits()[(*it)] = newData;
      }
      return false;
    }
    default:
      return true;
    }
  }
  /*
  DEFINE_BTASK(Harass){
    fprintf(stderr, "harass\n");
    switch(lineNum){
    case 0:{
      TerrainBase::Loc target=state->getNearestEnemyControlCenter(objects);
      fprintf(stderr, "number of bases: %d\n",  state->getEnemyBases().size());
      FORALL(objects, it){
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::VICINITY,
                           TerrainBase::Task::INDIVIDUAL);


	task.goal.loc = target;
	task.goal.distance=4*16;
	task.objs.insert((*it));
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = task.goal.loc;
        newData.state = ExtraObjectData::POSITIONING;
	state->getFriendlyUnits()[(*it)] = newData;
      }
      ++lineNum;
      return false;
    }
    case 1:{
      GameObj* workertarget=state->getNearestEnemyWorker(objects);
      FORALL(objects, it){
	if(state->getFriendlyUnits()[(*it)].state==ExtraObjectData::HARASS){
	  TerrainBase::Task task(TerrainBase::Goal::OBJ, TerrainBase::Goal::TOUCH,
                           TerrainBase::Task::INDIVIDUAL);
	  task.goal.obj = workertarget;
	  task.objs.insert((*it));
	  state->simAI->doPath(task);
	  ExtraObjectData newData;
	  newData.target = workertarget;
	  newData.state = ExtraObjectData::HARASS;
	  state->getFriendlyUnits()[(*it)] = newData;
	}
	else if(state->getFriendlyUnits()[(*it)].state==ExtraObjectData::FLEE){
	  if(state->noEnemyInRange((*it)))
	    state->getFriendlyUnits()[(*it)].state=ExtraObjectData::POSITIONING;
	}
	else if(state->getFriendlyUnits()[(*it)].state==ExtraObjectData::POSITIONING){
	  TerrainBase::Loc target=state->getNearestEnemyControlCenter(objects);
	  TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::VICINITY,
				 TerrainBase::Task::INDIVIDUAL);
	   
	  task.goal.loc = target;
	  task.goal.distance=4*16;
	  task.objs.insert((*it));
	  state->simAI->doPath(task);
	  ExtraObjectData newData;
	  newData.location = task.goal.loc;
	  newData.state = ExtraObjectData::POSITIONING;
	  state->getFriendlyUnits()[(*it)] = newData;
	}
      }
      return false;
    }
    default:
      return true;

    }    
  }
  */
  
  DEFINE_BTASK(MassAttack){
    if(!(state->getEnemyBases().size()))
      return true;

    GameObj * target = state->getNearestEnemyControlCenter(objects);
    if(target == NULL)
      return true;

    Vector<TerrainBase::Loc> locs = state->terrMap->find_free_edge(target);
    if(locs[0] == TerrainBase::Loc(-1,-1) )
      return true;

    switch(lineNum){
    case 0:{
      FORALL(objects, it){
	TerrainBase::Task task(TerrainBase::Goal::LOCATION, TerrainBase::Goal::TOUCH, TerrainBase::Task::INDIVIDUAL);

	state->terrMap->print_map();
	std::cout << "Target is at (" << locs[0].x/16 << "," << locs[0].y/16 << ")" << std::endl;

	task.goal.loc = locs[0];
	task.objs.insert((*it));
	state->simAI->doPath(task);
	ExtraObjectData newData;
	newData.location = locs[0];
	newData.state = ExtraObjectData::ATTACK;
	state->getFriendlyUnits()[(*it)] = newData;
      }
      lineNum++;
      return false;
    }
    default:
      return true;
    }
  }
        
  /*
  Task* createAttackAndDefend(uint4 id, BuildTasksState* s, ObjectVector& o,real8 timeout){
    return new MassAttack(id,s,o,createAttackAndDefend,"AttackAndDefend",timeout);
  }
  */
  Task* createBuildandTrain(uint4 id, BuildTasksState* s, ObjectVector& o,real8 timeout){
    return new BuildandTrain(id,s,o,createBuildandTrain,"BuildandTrain",timeout);
  }
  /*
  Task* createHarass(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    return new Harass(id,s,o,createHarass,"Harass",timeout);
  }
  */
  Task* createTrainMarine(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    fprintf(stderr, "spamming marines now\n");
    return new TrainMarine(id,s,o,createTrainMarine,"TrainMarine",timeout);
  }
  Task* createTrainTank(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    return new TrainTank(id,s,o,createTrainTank,"TrainTank",timeout);
  }
  Task* createTrainWorker(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    return new TrainWorker(id,s,o,createTrainWorker,"TrainWorker",timeout);
  }
  Task* createMassAttack(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    return new MassAttack(id,s,o,createMassAttack,"MassAttack",timeout);
  }
  Task* createScout(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout){
    fprintf(stderr, "scout\n");
    return new Scout(id,s,o,createTrainWorker,"Scout",timeout);
  }

}



