#ifndef PLAYER_ACTIONS_H
#define PLAYER_ACTIONS_H

#include "Global.H"

class GameObj;

class PlayerActionHandler
{
public:
	PlayerActionHandler() {}
	virtual ~PlayerActionHandler() {}
	
	virtual void stop(GameObj * unit);
	virtual void move(GameObj * unit, sint4 x, sint4 y);
	virtual void attack(GameObj * unit, GameObj * target);
	virtual void gather(GameObj * unit, GameObj * target);
	virtual void build(GameObj * unit, const std::string & bp_name,
					   sint4 x, sint4 y);

	virtual void scout(GameObj * unit);
	virtual void autoAttack(GameObj * unit);

	// MULTIPLE UNIT FUNCTIONS
	template<class CONT> void stopAll(const CONT & units)
	{
		FORALL(units, u) { stop(*u); }
	}
	
	template<class CONT> void moveAll(const CONT & units, sint4 x, sint4 y)
	{
		FORALL(units, u) { move(*u, x, y); }
	}

	template<class CONT> void buildAll(const CONT & units,
									   const std::string & bp_name,
									   sint4 x, sint4 y)
	{
		FORALL(units, u) { build(*u, bp_name, x, y); }
	}
	
	template<class CONT> void scoutAll(const CONT & units)
	{
		FORALL(units, u) { scout(*u); }
	}

	template<class CONT> void autoAttackAll(const CONT & units)
	{
		FORALL(units, u) { autoAttack(*u); }
	}
};

#endif
