#ifndef ProfileWidget_H
#define ProfileWidget_H

// $Id: ProfileWidget.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "CWidget.H"
#include "Profiler.H"

//===================================================================

/** Displays the results of Profiler in collapsable tree form. */

class ProfileWidget : public CWidget
{

private:
  enum LevelState { OPEN, CLOSED, EMPTY };
  std::map<ProfileLevel*, LevelState> tree_state;
  bool write_avg; ///< Display the average time instead of the total.
  std::string avg_text;

  Vector<ProfileLevel*> pl_at_line;

public:
  // public to allow REGISTER_TYPEOF definitions
  typedef std::map<ProfileLevel*, LevelState> ProfileLevel2LevelStateMap;

public:

  ProfileWidget();
  void draw_level(ProfileLevel *pl, sint4 &x, sint4 &y);

protected:
  stype event_mouse_down(stype x, stype y, stype b);
  stype event_key_down(stype key, stype mod, stype x, stype y);

  stype draw();
};

//===================================================================

REGISTER_TYPEOF(271,ProfileWidget::ProfileLevel2LevelStateMap::iterator);
REGISTER_TYPEOF(272,ProfileWidget::ProfileLevel2LevelStateMap::const_iterator);

#endif
