#ifndef SoundMixer_H
#define SoundMixer_H

// $Id: SoundMixer.H 5279 2007-06-23 02:49:08Z mburo $
 
// This is an ORTS file (c) Michael Buro, licensed under the GPL
// based on 

#include "Global.H"

extern int sound_test(const std::string &path);

struct Sound
{
  Uint8 *data;
  Uint32 length;
  
  Sound() { data = 0; length = 0; }
  ~Sound();
};


class SoundMixer {

public:

  struct Voice
  {
    sint2 *data;
    uint4 length;
    uint4 position;
    boost::array<sint2,2> vol; // 0:left 1:right
  };

  Vector<Voice> voices;
  SDL_AudioSpec audiospec;
  bool die;

  SoundMixer() { is_open = false; }

  uint4 play(Sound &sound, real4 lvol, real4 rvol);

  // return 0 <=> OK
  sint4 open();

  void close();

  // return 0 <=> OK
  static sint4 load_sound(const std::string &filename, Sound &sound);

protected:
  
  static void flip_endian(uint1 *data, uint4 length);

private:

  bool is_open;
};

#endif

