#ifndef SplashScreen_H
#define SplashScreen_H

// $Id: SplashScreen.H 5279 2007-06-23 02:49:08Z mburo $

#include "Global.H"
#include "GfxGlobal.H"
#include "GameObj.H"
#include "Image.H"

/**
 * @class SplashScreen
 * start up screen to show status and current task
 */

class SplashScreen{

public:
  SplashScreen() { background = 0;}
  SplashScreen(sint4 x, sint4 y, sint4 w, sint4 h, const std::string &version);
 
  void draw();

  void set_status(real8 status_);
  void set_max(sint4 max_){max = max_;}
  void set_dim(sint4 x, sint4 y, sint4 w, sint4 h);
  void set_current_task(const std::string& task_);
  
  void operator++(int) {
    set_status(status+1);
  }
  
  void set_background(const Image &image);

  void turn_off();
  void turn_on() { off = false; }
  bool enabled() { return !off; }

private:
  std::string version;

  real8 status; // current count
  real8 max;    // maximum count

  std::string task; // current task

  sint4 x;
  sint4 y;
  sint4 h;
  sint4 w;
  
  // atributes of the progress bar
  sint4 bar_x;
  sint4 bar_y;
  sint4 bar_h;
  sint4 bar_w;
  
  GLuint background;
  
  bool off;
  
  void print(uint4 x, uint4 y, const char *text, GLvoid *font, bool shadow = false);
};

#endif
