// $Id: TextWidget.C 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file
// (c) Sami Wagiaalla

#include "TextWidget.H"
#include "GfxModule.H"

using namespace std;

TextWidget:: TextWidget(): CWidget(){
  margin = 5; 
}

stype TextWidget::draw() {

  sint4 X = x.to_int();
  sint4 Y = y.to_int();
  sint4 W = w.to_int();
  sint4 H = h.to_int();

  sint4 x1 = X;
  sint4 y1 = Y;
  sint4 x2 = X+W;
  sint4 y2 = Y+H;


  glDisable(GL_TEXTURE_2D);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  //====Background=========
  glColor4f(0, 0, 0, 0.4);
  glBegin(GL_QUADS);
    glVertex2f(x2, y1);
    glVertex2f(x2, y2);
    glVertex2f(x1, y2);
    glVertex2f(x1, y1);
  glEnd();
 
  glColor4f(1, 1, 1, 1);

  //====Border=============
  glDisable(GL_TEXTURE_2D);
  glBegin(GL_LINE_LOOP);
    glVertex2f(x2, y1);
    glVertex2f(x2, y2);
    glVertex2f(x1, y2);
    glVertex2f(x1, y1);
  glEnd();

  glEnable(GL_SCISSOR_TEST);
  glScissor(X+1,Y+1,W-1,H-1);

  //===Text===============
  string wrapped = wrap(text,(W-2*margin)/8-1);

  render_bitmap_string(X+margin, Y + H - 20,GLUT_BITMAP_8_BY_13 , wrapped.c_str());

  glDisable(GL_BLEND);
  glEnable(GL_TEXTURE_2D);

  glDisable(GL_SCISSOR_TEST);
  return stype();
}


string TextWidget::wrap(const string& s, int count){
  string wrapped;
  wrapped = s;

  if(count == 0){
    // ERR("Cannot wrap string at 0");
  }

  sint4 c=0;
  for( uint4 i = 1; i < wrapped.length(); i++, c++){
    if(c == count){
      wrapped.insert(i, string("\\n"));
      c = 0;
      i += 3;
    }
  }

  return wrapped;
}
