#ifndef TextureStore_H
#define TextureStore_H

/** @file TextureStore.H
    Global interface for creating OpenGL textures from files.

    $Id: TextureStore.H 7358 2008-08-07 02:54:21Z furtak $
    $Source$
*/

// This is an ORTS file
// (c) Tim Furtak
// licensed under the GPL

#include "GfxGlobal.H"
#include "Image.H"

//===================================================================

/** An interface to create and keep track of textures loaded from files.
    Slightly limited in that the standard model textures (base, team)
    have support for gamma and down-scaling, so this class isn't
    appropriate to load them.
 */

class TextureStore
{
public:

  static GLuint load(const std::string &filename, Image::FILTER filter=Image::LINEAR, GLuint id=0);
  static void reload(const std::string &filename);
  static void unload(const std::string &filename);

  static void reload(GLuint id);
  static void unload(GLuint id);

protected:

  static std::map<std::string, GLuint> file2tex;
  static std::map<GLuint, std::string> tex2file;
};


#endif
