// $Id: VCRWidget.C 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "VCRWidget.H"
#include "GfxGlobal.H"
#include "GfxModule.H"

using namespace std;

const sint4 VCRWidget::FROM = EventFactory::new_who();
const sint4 VCRWidget::SET_SPEED = EventFactory::new_what();

//===================================================================

VCRWidget::VCRWidget()
{
  set_name("VCR");
}

//===================================================================

stype VCRWidget::event_key_down(stype key, stype /*mod*/, stype x, stype y)
{
  if (is_outside(x,y)) return stype();

  if (key.to_int() == '\t') {
    return stype(1);
  }
  return stype();
}

//===================================================================

stype VCRWidget::event_mouse_down(stype /*mx*/, stype my_, stype /*mb*/)
{
  if (is_outside(x,y)) return stype();

  sint4 my = my_.to_int();

  sint4 dy = h.to_int() - (my - y.to_int());
  if (dy <= 0) return stype(1);

  return stype(1);
}

//===================================================================

stype VCRWidget::draw()
{
  glDisable(GL_TEXTURE_2D);

  sint4 X = x.to_int();
  sint4 Y = y.to_int();
  sint4 W = w.to_int();
  sint4 H = h.to_int();

  // black background
  glColor4f(0, 0, 0, 0.5);
  glBegin(GL_QUADS);
  glVertex2f(X,   Y);
  glVertex2f(X+W, Y);
  glVertex2f(X+W, Y+H);
  glVertex2f(X,   Y+H);
  glEnd();

  glEnable(GL_SCISSOR_TEST);
  glScissor(X, Y, W, H);

  //  sint4 start_x = X + 10;
  //  sint4 start_y = Y + H - 14;

  glColor3f(1, 1, 1);

  // white border
  glColor4f(0.5, 0.5, 0.5, 1);
  glBegin(GL_LINE_LOOP);
  glVertex2f(X    , Y);
  glVertex2f(X+W-1, Y);
  glVertex2f(X+W-1, Y+H-1);
  glVertex2f(X    , Y+H-1);
  glEnd();

  glEnable(GL_TEXTURE_2D);
  glDisable(GL_SCISSOR_TEST);

  return stype();
}

//===================================================================

