#ifndef WaterTile_H
#define WaterTile_H

// $Id: WaterTile.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file
// (c) Keith Yerex

#include "GfxGlobal.H"
#include "GfxObject.H"
#include "Shader.H"

class WaterTile : public GfxObject
{
public:
  
  WaterTile(const Vec3<real4> *verts);

  void init(const Vec3<real4> &pos);
  virtual void update(real4 dt);
  virtual void draw();
  virtual void pick();

  DrawOrder order() const { return O_WATER; }
  virtual ~WaterTile() { tiles.erase(this); }

  static GLfloat texgen_s[];
  static GLfloat texgen_t[];

  static void anim(real4 dt);
  static void beginDraw();
  static void endDraw();
  static GLuint tex;

  static ShaderProgram water_shader;

protected:
  static real4 t;
  static std::set<WaterTile*> tiles;
  Vec3<real4> vert[4];
  Vec3<real4> orig[4];
};

REGISTER_TYPEOF(1500, std::set<WaterTile*>::iterator);

#endif
