#ifndef Array_H
#define Array_H
 
// $Id: Array.H 5407 2007-07-10 09:37:53Z furtak $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

// unsuitable for classes! awful hack ... but much faster than vector.

extern uint8 alloc_n;
extern uint8 init_n;
extern uint8 alloc_s;

template <class T, sint4 N0=6> class Array {

protected:

  sint4 n;
  sint4 n_max;
  T     *a;
  char  a0[N0*sizeof(T)];
  
  void free() {
    if (a && a != reinterpret_cast<T*>(a0)) { ::free(a); a = 0; }
  }

  void copy(const Array& x) {
    n = x.n;
    n_max = x.n_max;
    if (reinterpret_cast<char*>(x.a) != x.a0) {
      a = reinterpret_cast<T*>(::malloc(sizeof(T) * n));
      n_max = n;
    } else
      a = reinterpret_cast<T*>(a0);

    NO_OVERLAP(a, x.a, n);
    memcpy(a, x.a, n*sizeof(T));
  }
    
public:

  void init() {
    assert(N0>0);
    n = 0;
    a = reinterpret_cast<T*>(a0);
    n_max = N0;    
  }
  
  Array() {
    init_n++;
    init();
  }

#if 0  
  void alloc(sint4 i) {
    if (i <= 0) ERR("i<=0 in alloc");
    free();
    sint4 s = sizeof(T) * i;
    cout << "FOO " << s << endl;
    
    if (i > n_max) {
      n_max = i;
      a = (T*) malloc(s);
      cout << "FOO " << a << endl;      
    }
    if (!a) ERR("out of memory (Array::alloc)"); 
    alloc_n++;
    alloc_s += s;
    n = 0;
  }
#endif
  
  void push_back(const T &x) {

    if (n >= n_max) {

      if (n_max == 0) {

	n_max = N0;
	a = reinterpret_cast<T*>(a0);
	n = 0;

      } else {

#ifndef NDEBUG
	if (0) std::cout << "enlarge Array" << std::endl;
#endif	
	n_max += 2;
	n_max *= 3;
	n_max /= 2;
	sint4 s = sizeof(T) * n_max;
	T *p = reinterpret_cast<T*>(::malloc(s));
	if (!p) ERR("out of memory (Array::push_back)");
	NO_OVERLAP(p, a, n);
	memcpy(p, a, n * sizeof(T));
	free();
	a = p;
	alloc_n++;
	alloc_s += s;
      }
    }

    // cout << "a0=" << a0 << " a=" << a << " " << n << endl;
    a[n++] = x;
  }

  sint4 size() const { return n; }

  inline void set_size(sint4 i) {
    assert (i <= n_max);
    assert (i >= 0);
    //    if (i > n_max) ERR("Array::set_size: i>n_max");
    //    if (i < 0) ERR("Array::set_size: i<0");    
    n = i;
  }
  
  T &operator [](sint4 i) {
    assert(i >= 0 && i < n);
    return a[i];
  }

  const T &operator [](sint4 i) const {
    assert(i >= 0 && i < n);    
    return a[i];
  }  

  Array& operator=(const Array& x) {
    if (this != &x) {
      if (reinterpret_cast<char*>(a) != a0) free();
      copy(x);
    }
    return *this;
  }

  T *getArray() {

    return a;

  }

  const T *back() {
    return a[n];
  } 

  Array(const Array& x) { copy(x); }

  virtual ~Array() { free(); }
};

#endif
