#ifndef Attr_H
#define Attr_H

// $Id: Attr.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"
#include "SType.H"

//===================================================================

/** Attribute properties. */

class AttrProp {
public:
  sint4 index;  // of attribute value in vector
  bool constant;
  bool stable;               // mostly unchanging value
  bool visible_to_opponents;
  bool internal;             // script use only, not sent as part of update

  AttrProp(bool st=false, bool co=true, bool vo=false, bool in=false) :
    index(-1),     // set later
    constant(co), stable(st),
    visible_to_opponents(vo), internal(in)
  {}
};

//===================================================================

/*
union AttrVal {
  enum { MAX_INT = 1000000000, UNDEF_INT = 2000000000 };
  stype int_val;
  void *ptr_val;
  AttrVal() { int_val = 0; }
};
*/

//===================================================================

/** Component properties. */

class CompProp {
public:
  bool constant;
  bool visible_to_opponents;
  bool internal;

  CompProp(bool co=true, bool vo=false, bool in=false) :
    //    index(-1),     // set later
    constant(co),
    visible_to_opponents(vo), internal(in)
  {}
};

//===================================================================

#endif
