#ifndef BoolMatrix_H
#define BoolMatrix_H

// $Id: BoolMatrix.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class BoolMatrix {

protected:
  
  sint4 nx, ny;
  Vector<Vector<uint1> > m; // slow, but easy to copy :)

public:
  
  BoolMatrix(sint4 nx_ = 2, sint4 ny_ = 2) {
    assert(nx_ >= 1 && ny_ >= 1);
    nx = nx_; ny = ny_;
    m.reserve(nx);
    FORS (x, nx) {
      Vector<uint1> mx;
      mx.reserve(ny);
      FORS (y, ny) mx.push_back(false);
      m.push_back(mx);
    }
  }

  virtual ~BoolMatrix() {}

  bool get(sint4 x, sint4 y) {
    //assert(x >= 0 && x < nx && y >= 0 && y < ny);
    return m[x][y];
  }

  void set(sint4 x, sint4 y, bool f) {
    //assert(x >= 0 && x < nx && y >= 0 && y < ny);
    m[x][y] = f;
  }
};
 
#endif
