#ifndef CycleCounter_H
#define CycleCounter_H

// $Id: CycleCounter.H 6832 2008-03-04 23:26:18Z furtak $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// x86 cycle counter, useful for profiling
// SYSTEM DEPENDENT!

#include "Global.H"

struct CycleCounter {

public:

  union {
    uint8 c8;
    struct { uint4 l, h; } c4;
  } count_;
  
  void stamp() {

#if defined __i386__ || defined __x86_64__
    __asm__ __volatile__ (".byte 0x0f,0x31" : "=a"(count_.c4.l),"=d"(count_.c4.h));
#elif defined WIN32
    uint4 time_low, time_high;
    __asm rdtsc
    __asm mov time_low, eax
    __asm mov time_high, edx
    count_.c4.l = time_low;
    count_.c4.h = time_high;
#else
    count_.c8 = 0;
#endif    
  }

  uint8 count() const { return count_.c8; }
  
  CycleCounter() { stamp(); }
};

#endif
