#include <functional>
#include <boost/function.hpp>
#include <boost/bind.hpp>

template <class OBJ, typename RET>
boost::function<RET()> make_delegate(OBJ * obj, RET (OBJ::*mfp)()) 
{ 
	return boost::bind(std::mem_fun(mfp), obj); 
}

template <class OBJ, typename RET>
boost::function<RET()> make_delegate(const OBJ * obj, RET (OBJ::*mfp)() const) 
{ 
	return boost::bind(std::mem_fun(mfp), obj); 
}

template <class OBJ, typename RET, typename P1>
boost::function<RET(P1)> make_delegate(OBJ * obj, RET (OBJ::*mfp)(P1)) 
{ 
	return boost::bind(std::mem_fun(mfp), obj, _1); 
}

template <class OBJ, typename RET, typename P1>
boost::function<RET(P1)> make_delegate(const OBJ * obj, RET (OBJ::*mfp)(P1) const) 
{ 
	return boost::bind(std::mem_fun(mfp), obj, _1); 
}

template <class OBJ, typename RET, typename P1, typename P2>
boost::function<RET(P1,P2)> make_delegate(OBJ * obj, RET (OBJ::*mfp)(P1,P2)) 
{
	return boost::bind(std::mem_fun(mfp), obj, _1, _2); 
}

template <class OBJ, typename RET, typename P1, typename P2>
boost::function<RET(P1,P2)> make_delegate(const OBJ * obj, RET (OBJ::*mfp)(P1,P2) const)
{ 
	return boost::bind(std::mem_fun(mfp), obj, _1, _2); 
}

template <class OBJ, typename RET, typename P1, typename P2, typename P3>
boost::function<RET(P1,P2,P3)> make_delegate(OBJ * obj, RET (OBJ::*mfp)(P1,P2,P3)) 
{
	return boost::bind(std::mem_fun(mfp), obj, _1, _2, _3); 
}

template <class OBJ, typename RET, typename P1, typename P2, typename P3>
boost::function<RET(P1,P2,P3)> make_delegate(const OBJ * obj, RET (OBJ::*mfp)(P1,P2,P3) const)
{ 
	return boost::bind(std::mem_fun(mfp), obj, _1, _2, _3); 
}

template <class OBJ, typename RET, typename P1, typename P2, typename P3, typename P4>
boost::function<RET(P1,P2,P3,P4)> make_delegate(OBJ * obj, RET (OBJ::*mfp)(P1,P2,P3,P4)) 
{
	return boost::bind(std::mem_fun(mfp), obj, _1, _2, _3, _4); 
}

template <class OBJ, typename RET, typename P1, typename P2, typename P3, typename P4>
boost::function<RET(P1,P2,P3,P4)> make_delegate(const OBJ * obj, RET (OBJ::*mfp)(P1,P2,P3,P4) const)
{ 
	return boost::bind(std::mem_fun(mfp), obj, _1, _2, _3, _4); 
}
