#ifndef FILELOADER_H_
#define FILELOADER_H_

// This is an ORTS file, licensed under the GPL

#include "Global.H"

#include <iostream>

// This class is not used by ORTS.
// The filename prefixes are hard-coded and can be changed using options.

class FileLoader
{
private:
  static void init();
  static void parseOptions();
  static std::string pathSeparator;
  static bool initialized;
  
  static std::string fixPathString(const std::string& pathstr);

  static bool load_file(const std::string& filename, const std::string& prefix, 
                        std::ifstream& stream, std::ios::openmode openmode);

  static FILE* fopen(const std::string& prefix, const std::string& file, const char* mode);
  
public:
  static std::vector<std::string> defaultFilePaths;
  static std::vector<std::string> optionsFilePaths;
  
  static bool load_file(const std::string& filename, std::ifstream& stream);

  static bool load_file(const std::string& filename, std::ifstream& stream, std::ios::openmode openmode);
  
  static FILE* fopen(const std::string& file, const char *mode);
};

#endif /*FILELOADER_H_*/
