#ifndef GameChanges_H
#define GameChanges_H

/** @file GameChanges.H
    Wrapper for all the changes in one game cycle.

    $Id: GameChanges.H 5279 2007-06-23 02:49:08Z mburo $
    $Source$
*/

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "GameObj.H"

class ScriptObj;

/** Wrapper for all game object changes in one game cycle. */

struct GameChanges
{
  Vector<sint4>    new_tile_indexes;
  Vector<ScriptObj::WPtr> new_objs;
  Vector<ScriptObj::WPtr> changed_objs;
  Vector<ScriptObj::WPtr> vanished_objs;
  Vector<ScriptObj::WPtr> dead_objs;
  Vector<ScriptObj::WPtr> new_boundaries;

  void clear()
  {
    new_tile_indexes.clear();
    new_objs.clear();
    changed_objs.clear();    
    vanished_objs.clear();
    dead_objs.clear();
    new_boundaries.clear();
  }
    
};


/** Wrapper for action queue changes */

struct ActionChanges
{
  Vector<GameObj::ActInfo> skipped;
  Vector<GameObj::ActInfo> executed;
  // Vector<GameObj::ActInfo> succeeded; 
  // Vector<GameObj::ActInfo> failed;    

  void clear()
  {
    skipped.clear();
    executed.clear();
    //succeeded.clear();
    //failed.clear();
  }

};

#endif

