/** @file GameTile.C
    @see Tile.H

    $Id: GameTile.C 5279 2007-06-23 02:49:08Z mburo $
*/
// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "GameTile.H"
#include "ByteData.H"

using namespace std;

boost::array<BitStrip**,4> *GameTile::edge_shadows;

//===================================================================
/*
void GameTile::read(istringstream &is)
{
  Tile::read(is);
  generate_shadows();
}

void GameTile::read(const char* &s)
{
  Tile::read(s);
  generate_shadows();
}
*/
void GameTile::read_b(ByteStream &s)
{
  Tile::read_b(s);
  generate_shadows();
}

void GameTile::clear()
{
  Tile::clear();

  boundaries = 0;
  v1w = -1;
  v1e = -1;
  boundary_N = boundary_S = boundary_E = boundary_W = 0;
  boundary_int = 0;
}

// fixme: explain what's going on here

void GameTile::generate_shadows()
{
  Vector<sint4> heights;

  if (split == TB_SPLIT) {

    heights.push_back(h[0]);
    heights.push_back(h[1]);
    heights.push_back(h[3]);
    heights.push_back(h[4]);
    heights.push_back(h[5]);
    heights.push_back(h[7]);

  } else {

    heights.push_back(h[6]);
    heights.push_back(h[0]);
    heights.push_back(h[1]);
    heights.push_back(h[2]);
    heights.push_back(h[3]);
    heights.push_back(h[5]);
  }

  sort(heights.begin(), heights.end());
  FORU (i, 5) sh[i] = heights[i];

  bool edges[6];
  sint4 walls[8][2] = { {6, 7}, {0, 1}, {2, 3}, {4, 5}, {1, 6}, {2, 5}, {0, 3}, {7, 4} };
  sint4 mapping[8] = {0,1,2,3,4,4,5,5};

  // matches the shadow profiles used in View.C
  sint4 key2prof[48] = { -1, 8, 9, 2, 10,  0,  3, 12, 11,  5,  1, 12,  4, 12, 12, 12,
                          6, 2, 2, 2,  4, 12, 12, 12,  4, 12, 12, 12,  4, 12, 12, 12,
                          7, 5, 3, 12, 3, 12,  3, 12,  5,  5, 12, 12, 12, 12, 12, 12 };

  min_vh = -1;   // z must be greater than this to lookup the shadow profile
  max_vh = 1000; // z must be less than ...

  FORU (k, 5) {
    FORU (i, 6) edges[i] = false;
    FORU (i, 8) {
      if ((h[walls[i][0]] > sh[k]) && (h[walls[i][1]] > sh[k])) {
        edges[mapping[i]] = true;
      }
    }
    sint4 key = 0;
    FORU (i, 4) {
      if (edges[i]) key += 1 << i;
    }
    //    if (split == TB_SPLIT && edges[4]) key += 16;
    //    if (split == BT_SPLIT && edges[5]) key += 32;
    if (split == TB_SPLIT && edges[5]) key += 16;
    if (split == BT_SPLIT && edges[4]) key += 32;

    prof[k] = key2prof[key];
    if (prof[k] == 12) min_vh = heights[k+1]; // the entire tile occludes
    if (prof[k] == -1) { // no obstruction
      if (k > 0)
        max_vh = heights[k-1];
    }
  }

  if (split == TB_SPLIT) {
    vis_h1 = max(h[7], max(h[6], h[4]));
    vis_h2 = max(h[0], max(h[1], h[3]));
  } else {
    vis_h1 = max(h[0], max(h[1], h[6]));
    vis_h2 = max(h[2], max(h[3], h[5]));
  }
}

//===================================================================
