#ifndef IdFactory_H
#define IdFactory_H

// $Id: IdFactory.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class IdFactory {

protected:

  std::set<uint4> avail;
  
public:

  IdFactory(sint4 n) { init(n); }

  void init(sint4 n)
  {
    assert(n > 1);
    for (sint4 i=1; i < n; i++) avail.insert(i);
  }

  uint4 next()
  {
    if (avail.empty()) {
      ERR("ran out of ids");
      return 0;
    }
    uint4 id = *avail.begin();
    avail.erase(avail.begin());

    // cout << "new ID= " << id << endl;
    return id;
  }

  bool free(uint4 id)
  {
    if (id == 0) return true;
    if (avail.insert(id).second == false) return true;
    return false;
  }

  void reserve(const Vector<uint4> &ids)
  {
    FORALL (ids, i) avail.erase(*i);
  }

  virtual ~IdFactory() {};
};

#endif
