#ifndef ShutDown_H
#define ShutDown_H

// $Id: ShutDown.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"
 
extern bool shut_down;

#ifndef SIGKILL
#define SIGKILL 9
#endif

static void signal_handler_shut_down(int) {
  shut_down = true; // graceful exit: let the application shut down
}

static void signal_handler_exit(int) {
  exit(20);
}

inline void signals_shut_down(bool graceful) 
{
#ifndef WIN32
  if (graceful) signal(SIGINT, signal_handler_shut_down);
  else          signal(SIGINT, signal_handler_exit);

  signal(SIGTERM, signal_handler_exit);  
  signal(SIGKILL, signal_handler_exit);
#endif
}

#endif
