#ifndef TCP_Client_H
#define TCP_Client_H

// $Id: TCP_Client.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// generic client (only I/O)

#include "Global.H"

struct RandSrc;

class IO_Buffer;

struct TCP_Client
{
  sint4 port;
  IO_Buffer *io;
  TCPsocket so;
  sint4 clev;
  RandSrc *rnd_delay; // milliseconds
  std::string host;

  // compression level, delay random number generator (0 = no delay)
  TCP_Client(sint4 clev_, RandSrc *rnd_delay_ = 0)
    : port(-1), io(0), so(0), clev(clev_), rnd_delay(rnd_delay_)
  { }

  void close();
  bool is_closed() const;
  TCPsocket socket() const { return so; }
  virtual ~TCP_Client();
  
  sint4 write(const std::string &msg);
  sint4 read(std::string &msg);

  bool is_good() const;
  
  // false iff OK
  virtual bool connect(const char *host_, sint4 port_);
};

#endif
