#ifndef FPS_H
#define FPS_H

// $Id: FPS.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

#ifdef GCC

struct timeval;

class FPS
{
public:

  FPS(sint4 d=5);
  ~FPS();
  
  real8 update();
  real8 getFPS() { return fps; }
  real8 getDt() { return dt; }

private:

  sint4 interval;
  sint4 p;

#if 1

  timeval *list;
 
#else
  
  timeb *list;

#endif
  
  real8 fps;
  real8 dt;
};

#else // win32 FPS

class FPS
{
public:

  FPS(sint4 d=5);
  ~FPS();
  
  real8 update();
  real8 getFPS() { return fps; }
  real8 getDt() { return dt; }

private:

  sint4 interval;
  sint4 p;

  DWORD *list;
  
  real8 fps;
  real8 dt;
};

#endif // GCC

#endif
