// template implementation

#include "Global.h"
#include "HalfEdge.h"

using namespace std;

HalfEdge::HalfEdge()
{
  _boundary = false;
  _constrained = false;

  _mark = 0;
  _leftEnd.first = false;
  _rightEnd.first = false;  
}

HalfEdge::~HalfEdge()
{
}


void HalfEdge::set(V* orgItr, V* destItr)
{
  _orgItr = orgItr;
  _destItr = destItr;
  _boundary = false;
  _constrained = false;

  _mark = 0;
  _leftEnd.first = false;
  _rightEnd.first = false;
}

void HalfEdge::removeID(int id)
{
  _ids.remove(id);

  if (_ids.empty()) {
    std::pair<bool,V*> lf(false,_orgItr);
    std::pair<bool,V*> rt(false,_destItr);

    setLeftEnd(lf);
    setRightEnd(rt);
    setUnconstrained();
  }
}


bool HalfEdge::hasConstraintID(int id)
{
  FORALL (_ids, it) {
    if ( *it == id) {
      return true;
    }
  }
  return false;
}

