#ifndef POLYGON_H
#define POLYGON_H

#include <cassert>
#include <vector>
#include "Point.h"

// sequence of points + id + closed flag

template <class P>
class Polygon : public std::vector<P>
{
public:

  Polygon() { _id = -1; _closed = false; }

  inline P& operator[](size_t i) {
    check(i);
    return std::vector<P>::operator[](i);
  }

  inline const P& operator[](size_t i) const {
    check(i);
    return std::vector<P>::operator[](i);
  }

  int getID() const { return _id; }
  void setID(int id) { _id = id; }

  bool isClosed() const { return _closed; }
  void setClosed(bool f) { _closed = f; }
  
  void set(std::vector<P>& points) {
    static_cast<std::vector<P>&>(*this) = points;
    _id = -1;
    _closed = false;
  }
  
private:

  //data

  int _id;
  bool _closed;

#ifdef NDEBUG
  inline void check(size_t) const { }
#else
  inline void check(size_t i) const { assert(i < this->size()); }
#endif
};

typedef Polygon<FPoint> FPolygon;
typedef Polygon<IPoint> IPolygon;

#endif

