#ifndef VERTEX_H
#define VERTEX_H

#include "Rational.h"

class Face;
class HalfEdge;

class Vertex 
{
public: //typedefs
  
  typedef Rational<> coord_t;
  typedef coord_t C;
  
  //typedef mpq_class coord_t;
  //typedef double coord_t;

  static const int INTERSECTION_LIMIT = 1000000; // intersections fit in Point<coord_t>
  
  Vertex() : _x(0),_y(0) { }
  Vertex(C& x, C& y);

public: //accessors and mutators

  const C& getX() const { return _x; }
  const C& getY() const { return _y; }
  C& getX() { return _x; }
  C& getY() { return _y; }

  void setX(const C& x) { _x = x; }
  void setY(const C& y) { _y = y; }
  void setXY(const C& x, const C& y) { _x = x; _y = y; }

  HalfEdge* getOutEdge() const { return _outEdge; }
  void setOutEdge(HalfEdge* e) { _outEdge = e; }

  int getVecIndex() const { return vecIndex; }
  void setVecIndex(int i) { vecIndex = i; }
  
private:

  //data

  C _x, _y;
  HalfEdge* _outEdge;    // set when vertex is created or outedge is modified
  int vecIndex; // position in vertex vector
};

#endif
