#ifndef TraDcdtLiteWidget_H
#define TraDcdtLiteWidget_H

// This is an ORTS file (c) Kai Chen, licensed under the GPL

#include "Global.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"
#include "DCDTLite.h"
#include "HalfEdge.h"


class GameStateModule;
class GfxModule;


class TraDcdtLiteWidget : public EventHandler
{
    GameStateModule & gsm;
	GfxModule & gfxm;
	DCDT & dcdt;
	
    DrawOnTerrain dot;
    bool enabled;
public:
    TraDcdtLiteWidget(GameStateModule & gsm, GfxModule & gfxm, DCDT & dcdt);

    bool is_enabled() const { return enabled; }
    void enable() { enabled = true; }
    void disable() { enabled = false; }
    void draw();

    bool handle_event(const Event &e);
};

#endif
