// $Id: BucketFactory.C 5279 2007-06-23 02:49:08Z mburo $

#include "BucketFactory.H"
using namespace std;


Vector<Bucket> BucketFactory::samples = Vector<Bucket>();
Vector<bool> BucketFactory::have_sample = Vector<bool>(samples.size(), false);

BucketFactory::BucketFactory() { }

BucketFactory::~BucketFactory() { }

// FIXME: UGLY FUNCTIONS

template <class T>
static void make_unique(Vector<T> &v)
{
  typename  Vector<T>::iterator j;
  FORALL_DYN (v, i) {
    for (j = i+1; j != v.end();) {
      if (*i == *j) {
	j = v.erase(j);
	continue;
      }
      ++j;
    }
  }
}

static void unique_x(Vector<Point2i> &v)
{
  Vector<Point2i>::iterator j;
  FORALL_DYN (v, i){
    for (j = i+1; j != v.end();) {
      if (i->x == j->x) {
	j = v.erase(j);
	continue;
      }
      ++j;
    }
  }
}

static void unique_y(Vector<Point2i> &v)
{
  Vector<Point2i>::iterator j;
  FORALL_DYN (v, i) {
    for (j = i+1; j != v.end();) {
      if (i->y == j->y) {
	j = v.erase(j);
	continue;
      }
      ++j;
    }
  }
}

Bucket BucketFactory::get_bucket(int r)
{
  if (r < 0) r = 0;
  if ((uint4)r < have_sample.size() && have_sample.at(r))
    return samples[r];

  // Bresenham circle algorithm
  // retrieved from http://www.gamedev.net/reference/articles/article767.asp and 
  // modified
  int X = 0;
  int Y = 0;

  Vector<Point2i> points; // points of the border of the bucket
  Vector<Point2i> N; // points of the north face of the bucket
  Vector<Point2i> E; // points of the north face of the bucket
  Vector<Point2i> S; // points of the north face of the bucket
  Vector<Point2i> W; // points of the north face of the bucket
  
  double d = 3 - 2*r;
  double x = 0;
  double y = r;

  while (x <= y) {
    X = (int)x;
    Y = (int)y;
    //Draw the 8 circle pixels

    points.push_back(Point2i( +X, +Y)); // SE
    S.push_back(Point2i( +X, +Y)); 
    E.push_back(Point2i( +X, +Y)); 
    
    points.push_back(Point2i( -X, +Y)); // SW
    S.push_back(Point2i( -X, +Y)); 
    W.push_back(Point2i( -X, +Y));
  
    points.push_back(Point2i( +X, -Y)); // NE
    N.push_back(Point2i( +X, -Y));
    E.push_back(Point2i( +X, -Y));
  
    points.push_back(Point2i( -X, -Y)); // NW
    N.push_back(Point2i( -X, -Y));
    W.push_back(Point2i( -X, -Y));
      
    points.push_back(Point2i( +Y, +X)); // SE
    S.push_back(Point2i( +Y, +X));
    E.push_back(Point2i( +Y, +X));

    points.push_back(Point2i( -Y, +X)); // SW
    S.push_back(Point2i( -Y, +X));
    W.push_back(Point2i( -Y, +X));

    points.push_back(Point2i( +Y, -X)); // NE
    N.push_back(Point2i( +Y, -X));
    E.push_back(Point2i( +Y, -X));

    points.push_back(Point2i( -Y, -X)); // NW
    N.push_back(Point2i( -Y, -X));
    W.push_back(Point2i( -Y, -X));

    if (d < 0) {
      d = d + (4 * x) + 6;
    } else {
      d = d + 4 * (x - y) + 10;
      y = y - 1;
    }

    x = x + 1;

  }

  make_unique(points);
  unique_x(N);
  unique_x(S);
  unique_y(E);
  unique_y(W);
  
  Bucket b(points);
  b.set_n(N);
  b.set_s(S);
  b.set_e(E);
  b.set_w(W);

  if (samples.size() <= (uint4)r) {
    samples.resize(r+1);
    have_sample.resize(r+1, false);
  }

  samples[r] = b;
  samples.erase(samples.begin()+r);
  samples.insert(samples.begin()+r, b);
  have_sample.erase(have_sample.begin()+r);
  have_sample.insert(have_sample.begin()+r, true);

  return b;
}
