#ifndef PathEvent_H
#define PathEvent_H

// $Id: PathEvent.H 5279 2007-06-23 02:49:08Z mburo $
      
// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "GfxGlobal.H"
#include "GameObj.H"
#include "Global.H"
#include "EventHandler.H"

//===================================================================

class PathEvent : public Event
{
public:
  
  PathEvent(sint4 who, sint4 what, const Coor3 &destination, const Vector<GameObj*> &objs_) :
    Event(who, what), dest(destination), objs(objs_) {}

  virtual ~PathEvent() {};
  
  Coor3 get_dest() const { return dest; }
  const Vector<GameObj*> &get_objs() const { return objs; }
  
protected:

  Coor3 dest;
  Vector<GameObj*> objs;
};

//===================================================================

class PathStopEvent : public Event
{
public:
  
  PathStopEvent(sint4 who, sint4 what, const Vector<GameObj*> &objs_) :
    Event(who, what), objs(objs_) {}

  virtual ~PathStopEvent() {};
  
  const Vector<GameObj*> &get_objs() const { return objs; }
  
protected:

  Vector<GameObj*> objs;
};

//===================================================================

#endif
