#ifndef PathFinder_H
#define PathFinder_H

// $Id: PathFinder.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "GameStateModule.H"
#include "GameChanges.H"
#include "PathEvent.H"
#include "Environment1.H"
#include "PathProcessor.H"
#include "EventHandler.H"

class SWidget;
class ClientState;

class PathFinder : public EventHandler
{
public:

  static const sint4 FIND_PATH_MSG;
  static const sint4 FIND_PATH_STOP;
  
  PathFinder(ClientState &c);
  ~PathFinder();

  bool handle_event(const Event &e);

  PathProcessor pp;
  
private:
  
  void init_env();
  void init_widget();

  void find_path(const PathEvent *pe);
  void update_paths(const Point2i &a, const Point2i &b);
  
  ClientState &state;
  
  SWidget *widget;
  
  sint4 widget_width;
  sint4 widget_height;
  
  int width;
  int height;
  int tile_points;
  
  std::queue<PathEvent> taskQ;
  Environment *env;
  SimpleMap<SizeCell> *map;
};

#endif

