#ifndef SimplePathfinderWidget_H
#define SimplePathfinderWidget_H

// $Id: SimplePathfinderWidget.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "CGridBase.H"
#include "SimplePathfinder.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"

class GfxModule;

//===================================================================

class SimplePathfinderOverlay : public EventHandler {
private:
  
  const SimplePathfinder *terrain_p;
  DrawOnTerrain dot;
  bool enabled;

  GfxModule *gfxm;

public:
  SimplePathfinderOverlay(const SimplePathfinder &terrain, GfxModule &gfxm);
 
  bool is_enabled() const { return enabled; }
  void enable() { enabled = true; }
  void disable() { enabled = false; }
  void draw();

  bool handle_event(const Event &e);
};

//-----------------------------------------------------------------

class SimplePathfinderWidget : public CGridBase
{
private:

  sint4 wwidth;
  sint4 wheight;

  bool draw_tiles;
  bool draw_air;

    
  const SimplePathfinder *terrain_p;
  SimplePathfinderOverlay *overlay;

public:

  SimplePathfinderWidget(const SimplePathfinder &terrain, GfxModule *gfxm=0);
  ~SimplePathfinderWidget();

  virtual stype event_key_down(stype key, stype mod, stype x, stype y);
  virtual stype draw();
};


//===================================================================

#endif
