#ifndef SIMPLEPFADAPTER_H
#define SIMPLEPFADAPTER_H
// $Id: SimplePFAdapter.H 5279 2007-06-23 02:49:08Z mburo $

#include "GlobalPathfinder.H"
#include "SimpleGlobalPF.H"
#include "TerrainBase.H"
#include "boost/shared_ptr.hpp"

class SimplePFAdapter : public GlobalPathfinder{
public:
  SimplePFAdapter();
  virtual ~SimplePFAdapter();
  /**\name GlobalPathfinder Methods */
  //@{
  virtual void init(sint4 tiles_x_, sint4 tiles_y_, sint4 tile_points_, sint4 client_pID_, sint4 neutral_pID_);
  virtual void insert_object(const Object *obj);
  virtual void remove_object(const Object *obj);
  virtual void update_object(const Object *obj);
  virtual void insert_boundaries(const Vector<Segment> &s);
  virtual bool find_path(const TerrainBase::Task& task, TerrainBase::Path& output,  TerrainBase::ConsiderObjects consider);
  //@}
protected:
  boost::shared_ptr<SimpleTerrain::SimpleGlobalPF> pfEngine;

  friend class SimpleGlobalPFOverlay;
};

#endif
