// $Id: bitVector.h 5279 2007-06-23 02:49:08Z mburo $

// HOG File

#ifndef _BITVECTOR_
#define _BITVECTOR_

#include <stdint.h>

/**
 * An efficient bit-wise vector implementation.
 */

namespace HOG{

class bitVector {
public:
  bitVector(int size);
  ~bitVector();
  void clear();
  bitVector *clone();
  int getSize() { return true_size; }
  bool get(int index) const;
  void set(int index, bool value);
  void merge(bitVector *);
  bool equals(bitVector *);
  int getNumSetBits();
private:
  int size, true_size;
  uint32_t *storage;
};
}
#endif
