/*
 * $Id: path.h 5279 2007-06-23 02:49:08Z mburo $
 *
 *  Hierarchical Open Graph File
 *
 *  Created by Nathan Sturtevant on 9/28/04.
 *  Copyright 2004 Nathan Sturtevant. All rights reserved.
 *
 */

#ifndef PATH_H
#define PATH_H

#include "graph.h"

namespace HOG {

class mapAbstraction;

/**
 * A linked list of nodes which form a continuous path.
 */
class path {
public:
  node *n;
  path *next;
	
  path(node *_n, path *_next=0) : n(_n), next(_next) {}
  ~path() { if (next != NULL) delete next; }
	path *clone() { return next?(new path(n, next->clone())):new path(n, next);}
	path *tail() { if (next) return next->tail(); return this; }
  unsigned length(void); 
  double distance(mapAbstraction* aMap);
  unsigned degree();
  void print(bool beginning=true);
};

}

#endif 
