/*
 * $Id: reservationProvider.h 5279 2007-06-23 02:49:08Z mburo $
 *
 *  reservationProvider.h
 *  HOG
 *
 *  Created by Nathan Sturtevant on 5/13/05.
 *  Copyright 2005 Nathan Sturtevant, University of Alberta. All rights reserved.
 *
 */

#ifndef RESERVATIONPROVIDER_H
#define RESERVATIONPROVIDER_H

#include "graph.h"

namespace HOG {

class unit;

class reservationProvider {
public:
	virtual ~reservationProvider() {};
	//virtual bool tileOccupied(int x, int y) = 0;	
	virtual bool nodeOccupied(node *) = 0;

	virtual bool canMove(node *from, node *to, double startTime, unit *) = 0;
	virtual bool reserveMove(node *from, node *to, double startTime, unit *) = 0;
	virtual bool clearMove(node *from, node *to, double startTime, unit *) = 0;
	virtual void clearAllReservations() = 0;
};

}

#include "unit.h"

#endif
