/*
 * $Id: searchAlgorithm.h 5279 2007-06-23 02:49:08Z mburo $
 *
 *  Hierarchical Open Graph File
 *
 *  Created by Nathan Sturtevant on 9/28/04.
 *  Copyright 2004 Nathan Sturtevant. All rights reserved.
 *
 */

#ifndef SEARCHALGORITHM_H
#define SEARCHALGORITHM_H

#include "graph.h"
#include "path.h"
#include "mapAbstraction.h"
#include "unitSimulation.h"
#include "reservationProvider.h"

/**
 * A generic algorithm which can be used for pathfinding.
 */
namespace HOG{
class searchAlgorithm {
public:
	searchAlgorithm() { nodesExpanded = nodesTouched = 0; }
	virtual ~searchAlgorithm() {}
	virtual const char *getName() = 0;
	virtual path *getPath(graphAbstraction *aMap, node *from, node *to, reservationProvider *rp = 0) = 0;
	int getNodesExpanded() { return nodesExpanded; }
	int getNodesTouched() { return nodesTouched; }
	virtual void logFinalStats(statCollection *stats) {}

	//protected:
	int nodesExpanded;
	int nodesTouched;
};

extern void doRandomPath(graphAbstraction *aMap, searchAlgorithm *sa, bool repeat = false);
}
#endif
