/*
 * $Id: sharedAMapGroup.h 5279 2007-06-23 02:49:08Z mburo $
 *
 *  sharedAMapGroup.h
 *  HOG
 *
 *  Created by Nathan Sturtevant on 12/16/04.
 *  Copyright 2004 University of Alberta. All rights reserved.
 *
 */


#include "unitGroup.h"

#ifndef SHAREDAMAPGROUP_H
#define SHAREDAMAPGROUP_H

/**
 * A group which incrementally builds a map of the world as the units in the group
 * explore the graph.
 */

namespace HOG{
class sharedAMapGroup : public unitGroup, public mapProvider {
public:
	sharedAMapGroup(mapProvider *);
	~sharedAMapGroup();
	virtual tDirection makeMove(unit *u, mapProvider *mp, reservationProvider *rp, simulationInfo *simInfo);
	virtual void openGLDraw(mapProvider *, simulationInfo *);
	virtual Map *getMap();
	virtual mapAbstraction *getMapAbstraction();
	virtual int getNewTileCount() { return newTileCountPerTrial; }
	
	/** reset the location of a given unit */
	virtual void updateLocation(unit *, mapProvider *m, int _x, int _y, bool, simulationInfo *);
	/** Is the group done with their exploration? */
	virtual bool done();
	/** Lets the unit group do what it needs to reset a trial */
	void startNewTrial(statCollection *stats);
	void logStats(statCollection *stats);
	
	void setVisibilityRadius(int _visibility);
	int getVisibilityRadius();
	bool explored(int x, int y);
	bool explored(unsigned int _node);
	//void printRoundStats(unit *, FILE *f);

        int getNewTileCountPerStep() { return newTileCount; }

        bool seenBefore(int x, int y) { return (seen->get(y * map->getMapWidth() + x)); }
	
protected:
	//void setUnitSimulation(unitSimulation *_us, Map *m);

	mapAbstraction *aMap;
	Map *map;
	bitVector *seen;
	int visRadius;
	bool sawNewLand;
	int newTileCount;
	int newTileCountPerTrial;
};
}
#endif
