#include "TraDcdtWidget.H"
#include "GameStateModule.H"
#include "GfxModule.H"
#include "GfxGlobal.H"
#include "Base.h"
#include "Profiler.H"
#include "Game.H"

using namespace std;
using boost::shared_ptr;

TraDcdtWidget::TraDcdtWidget(GameStateModule & gsm, GfxModule & gfxm, TraDcdt & dcdt) : gsm(gsm), gfxm(gfxm), dcdt(dcdt), dot(gfxm), enabled(false)
{

}

bool TraDcdtWidget::handle_event(const Event &e)
{
	if (e.get_who() == GfxModule::FROM)
	{
		if (e.get_what() == GfxModule::DRAW_MSG)
		{
			draw();
			return true;
		}
	}
	return false;
}

void TraDcdtWidget::draw()
{
	PROFILE("TraDcdtWidget");

	int polyNum = dcdt.num_polygons();
	if(polyNum >0 )
	{
	
		SrArray<SrPnt2> constr ;
		SrArray<SrPnt2> unconstr ;
		dcdt.get_mesh_edges(&constr, &unconstr);
		
		PROFILE("draw lines");

		Vec3<real4> color(1,1,1);
		dot.begin_lines();
		
		real4 x1, y1 , x2 , y2;
		sint4 tilepionts = gsm.get_game().get_tile_points();
		for(sint4 i=0; i<constr.size()-2; i+=2)
		{
			SrPnt2 p1 = constr[i];
			SrPnt2 p2 = constr[i+1];
			x1 = p1.x /tilepionts;
			y1 = p1.y /tilepionts;
			x2 = p2.x /tilepionts;
			y2 = p2.y /tilepionts;
			
			dot.draw_line(x1, y1, x2, y2, color, 1.0);
		}
		
		dot.end_lines();
		
		Vec3<real4> color2(0,1,0);
		dot.begin_lines();
		
		for(sint4 i=0; i<unconstr.size()-2; i+=2)
		{
			SrPnt2 p1 = unconstr[i];
			SrPnt2 p2 = unconstr[i+1];
			x1 = p1.x /tilepionts;
			y1 = p1.y /tilepionts;
			x2 = p2.x /tilepionts;
			y2 = p2.y /tilepionts;
			
			dot.draw_line(x1, y1, x2, y2, color2, 1.0);
		}
		
		dot.end_lines();
	}
}
