#ifndef TraDcdtWidget_H
#define TraDcdtWidget_H

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"

class GameStateModule;
class GfxModule;
class TraDcdt;

class TraDcdtWidget : public EventHandler
{
    GameStateModule & gsm;
	GfxModule & gfxm;
	TraDcdt & dcdt;
	
    DrawOnTerrain dot;
    bool enabled;
public:
    TraDcdtWidget(GameStateModule & gsm, GfxModule & gfxm, TraDcdt & dcdt);

    bool is_enabled() const { return enabled; }
    void enable() { enabled = true; }
    void disable() { enabled = false; }
    void draw();

    bool handle_event(const Event &e);
};

#endif
