//-----------------------------------------------------------------------------
/** @file searchutils.h
    Utilities for running searches.

    $Id: searchutils.h 5279 2007-06-23 02:49:08Z mburo $
    $Source$
*/
//-----------------------------------------------------------------------------

#ifndef PATHFIND_SEARCHUTILS_H
#define PATHFIND_SEARCHUTILS_H

#include "environment.h"

//-----------------------------------------------------------------------------

namespace PathFind
{
    using namespace std;

    /** Utility operations for running searches. */
    class SearchUtils
    {
    public:
        bool checkPathExists(const Environment& env, int start, int target);

        void findRandomStartTarget(const Environment& env,
                                   int& start, int &target);

    private:
        int m_target;

        const Environment* m_env;

        vector<bool> m_mark;

        vector<vector<Environment::Successor> > m_successorStack;

        bool searchPathExists(int node, int depth);
    };
}

//-----------------------------------------------------------------------------

#endif
