#ifndef ClientModule_H
#define ClientModule_H

// $Id: ClientModule.H 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// base class for client side modules
// it's an event generator

#include "Global.H"
#include "EventHandler.H"

//===================================================================

/** This object generates events and sends them to a list of registered
    event handlers.
*/

class ClientModule
{
public:

  virtual ~ClientModule() {}
  
  // event handlers
  void add_handler(EventHandler *h) { el.add(h); }
  void remove_handler(EventHandler *h) { el.remove(h); }

protected:

  sint4 call_handlers(const Event &e) { return el.call(e); }

  EventHandlerList el;
};

#endif
