#ifndef SI_MAPOBJECT_H
#define SI_MAPOBJECT_H

// $Id: SI_MapObject.h 5279 2007-06-23 02:49:08Z mburo $

#include "Global.H"

#include "SI_Vector3D.h"


namespace Simul{
  const real8 UNIT_SIZE=5.0; // how large is each unit represented
  const uint4 CIRCLE_DETAIL=24; // shows how many triangles will make up the circle when drawing it
  const uint4 GROUP_TYPE_ID=0;
  const uint4 BASE_TYPE_ID=1;

  class Group;

  class MapObject
  {
  public:
    MapObject(uint4 playerID);
    MapObject(const MapObject& obj);
    virtual ~MapObject();

    virtual MapObject* clone() const = 0;

    virtual bool withinRange(Group* otherObject)=0;

    virtual double getExtents() const=0;
    //virtual void draw()=0;
    //virtual void drawInSelectionMode();

    Vector3D getPosition() const {return position;}
    void setPosition(const Vector3D& pos) {this->position = pos;}

    uint4 getPlayerID() {return playerID;}
  protected:

    Vector3D position;

    bool wasHit;

  private:
    MapObject& operator=(const MapObject& b);

    uint4 playerID;
  };
}
#endif
