OBJDIR=obj\win

CC      = cl.exe
CC_OPTS = -nologo -D "WIN32" -D "NDEBUG" -GX -MD -GR -D "GLEW_STATIC" -Zc:forScope -Tp
OPT     = -Ob2 -O2 -G7 -Og -Oy -D "TRANSFORM_MOUSE_Y"

INC = /I "config" \
	/I "libs\kernel\src" \
	/I "libs\serverclient\src" \
	/I "libs\gfxclient\src" \
	/I "libs\network\src" \
	/I "libs\newpath\src" \
	/I "libs\ai\low\src" \
	/I "c:\SDL-1.2.11\include" \
	/I "c:\SDL_net-1.2.5\include" \
	/I "c:\zlib122-dll\include" \
	/I "c:\glut-3.7.6-bin" \
	/I "c:\glew-1.3.3-win32\include" \
	/I "win32\include"

#####################################################

default: orts ortsg

#####################################################

LOPT = \
	/SUBSYSTEM:CONSOLE \
	/INCREMENTAL:no \
	/MACHINE:X86

LPATH = \
	/LIBPATH:"c:\program files\microsoft visual c++ toolkit 2003\lib" \
	/LIBPATH:"c:\SDL-1.2.11\lib" \
	/LIBPATH:"c:\SDL_net-1.2.5\lib" \
	/LIBPATH:"c:\zlib122-dll\lib" \
	/LIBPATH:"c:\glut-3.7.6-bin" \
	/LIBPATH:"c:\glew-1.3.3-win32\lib" \

LIBS = \
	SDL.lib \
	SDLmain.lib \
	SDL_net.lib \
	zdll.lib \
	glut32.lib \
	glew32s.lib

#####################################################
# rules for subdirectories in libs\
#####################################################

SRCDIR = kernel
{libs\$(SRCDIR)\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

SRCDIR = serverclient
{libs\$(SRCDIR)\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

SRCDIR = network
{libs\$(SRCDIR)\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

SRCDIR = gfxclient
{libs\$(SRCDIR)\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

SRCDIR = newpath
{libs\$(SRCDIR)\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

SRCDIR = ai\low
{libs\$(SRCDIR)\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

{apps\orts\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

{apps\ortsg\src}.c{$(OBJDIR)}.obj :
	$(CC) -c $(INC) $(OPT) $(CC_OPTS) $< /Fo$@

#####################################################

KERNEL_OBJ = \
	Action.obj \
	Array.obj \
	Blueprints.obj \
	Collision.obj \
	Collision2D.obj \
	Compress.obj \
	Distance.obj \
	FileArchive.obj \
	GUI.obj \
	Game.obj \
	GameConst.obj \
	GameObj.obj \
	GameObjFactory.obj \
	GameScript.obj \
	GameTile.obj \
	Global.obj \
	Motion.obj \
	Options.obj \
	PlayerInfo.obj \
	Profiler.obj \
	Random.obj \
	Replayer.obj \
	SDL_gfxPrimitives.obj \
	SDLinit.obj \
	Script.obj \
	ScriptParser.obj \
	ScriptSet.obj \
	ScriptString.obj \
	ScriptVector.obj \
	ServerObjData.obj \
	ShutDown.obj \
	SType.obj \
	Terrain.obj \
	Tile.obj \
	Token.obj \
	View.obj \
	View2.obj \
	Vision.obj

SERVERCLIENT_OBJ = \
	EventHandler.obj \
	GameStateModule.obj \
	MapCliff.obj \
	MapCTF.obj \
	MapMarine.obj \
	MapRandomIsland.obj \
	MapTool.obj \
	PathfinderBasicImp.obj \
	Server.obj \
	TerrainBase.obj \
	TerrainModule.obj \
	TournamentMapTool.obj

NETWORK_OBJ = \
	IO_Buffer.obj \
	TCP_Client.obj \
	TCP_Server.obj \
	Text_IO_Buffer.obj

GFXCLIENT_OBJ = \
	CGridBase.obj \
	CWidget.obj \
	Demo_SimpleTerrainWidget.obj \
	DrawOnTerrain.obj \
	FPS.obj \
	Frustum.obj \
	Gfx2d.obj \
	Gfx2d2.obj \
	GfxAnimesh.obj \
	GfxDrawPick.obj \
	GfxEmitter.obj \
	GfxGlobal.obj \
	GfxInit.obj \
	GfxLinAlg.obj \
	GfxModule.obj \
	GfxModule2.obj \
	GfxObject.obj \
	GfxOpt.obj \
	GfxScript.obj \
	GfxTerrain.obj \
	GfxTerrainTile.obj \
	Image.obj \
	KeyMap.obj \
	LayoutHV.obj \
	MD2.obj \
	MD3.obj \
	Minimap.obj \
	Octree.obj \
	ProfileWidget.obj \
	ScriptEmitter.obj \
	ScriptModel.obj \
	ScriptObjSet.obj \
	Shader.obj \
	SoundMixer.obj \
	SplashScreen.obj \
	TextWidget.obj \
	VCRWidget.obj \
	WaterTile.obj

AI_OBJ = \
	GatherAI.obj \
	PersueAttack.obj \
	TurretAI.obj

NEWPATH_OBJ = \
	Demo_SimpleTerrain.obj \
	Demo_ST_Bucket.obj \
	Demo_ST_PFEngine.obj

#####################################################

$(KERNEL_OBJ) : $(OBJDIR)\$@
$(SERVERCLIENT_OBJ) : $(OBJDIR)\$@
$(NETWORK_OBJ) : $(OBJDIR)\$@
$(GFXCLIENT_OBJ) : $(OBJDIR)\$@
$(AI_OBJ) : $(OBJDIR)\$@
$(NEWPATH_OBJ) : $(OBJDIR)\$@
orts_main.obj : $(OBJDIR)\$@
ortsg_main.obj : $(OBJDIR)\$@

#####################################################

ORTS_OBJ = $(KERNEL_OBJ) $(SERVERCLIENT_OBJ) $(NETWORK_OBJ) orts_main.obj
ORTSG_OBJ = $(KERNEL_OBJ) $(SERVERCLIENT_OBJ) $(NETWORK_OBJ) $(GFXCLIENT_OBJ) $(AI_OBJ) $(NEWPATH_OBJ) ortsg_main.obj

orts: $(ORTS_OBJ)
	pushd $(OBJDIR) & \
	link $(LOPT) $(LIBS) $(LPATH) /OUT:..\..\orts.exe $(ORTS_OBJ) & \
	popd

ortsg: $(ORTSG_OBJ)
	pushd $(OBJDIR) & \
	link $(LOPT) $(LIBS) $(LPATH) /OUT:..\..\ortsg.exe $(ORTSG_OBJ) & \
	popd
