// $Id: client_temp.C 5279 2007-06-23 02:49:08Z mburo $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// client template, see orts.C for a working sample

#include "Global.H"
#include "Options.H"
// uncomment:
// #include "MyClient.H"  // this one has to be created (see TestClient.H,C)

void signal_handler(int) { exit(1); }

const char *CLIENT_VERSION = "Client version 1.00 (2003-June-24)";

Options opt;

static void add_options(Options &opt) {
  
  opt.put("-seed", 1, "rnd number seed (0:time)");
  opt.put("-clev", 4, "compression level");
  opt.put("-cpind", 0, "client player index");      
  opt.put("-shost", string("localhost"), "server host");
  opt.put("-sport", 7777, "server port");

  // ...

}


int main(sint4 argc, char **argv)
{
  signal(SIGINT,  signal_handler);
  signal(SIGTERM, signal_handler);  
  signal(SIGKILL, signal_handler);

  // process command line arguments
  if (opt.process(argc, argv, cerr, CLIENT_VERSION)) exit(20);

  sint4 seed;
  opt.get("-seed", seed);

  if (seed == 0) seed = time(0);
  cout << "seed=" << seed << endl;
	rand.srand(seed);
  srand48(seed);       // used by STL

  MyClientEnv ce(opt);
  ce.run();            // start client loop (see TestClient.C)

  return 0;
}
