/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header$
  $Log$
  Revision 1.1  2004/10/11 09:09:18  orts_mburo
  Initial revision

  Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
  import

*/

#ifndef Array_H
#define Array_H
 
#include "Global.H"
//#include "Alloc.H"

// only useful for integers!!! awfull hack ...

extern uint8 alloc_n;
extern uint8 init_n;
extern uint8 alloc_s;

template <class T, int N0=6> class Array {

public:

  sint4 n;
  sint4 n_max;
  T     *a;
  char  a0[N0*sizeof(T)];
  
  void free() {
    if (a && a != (T*)a0) { ::free(a); a = 0; }
  }

public:

  inline void init() {
    assert(N0>0);
    n = 0;
    a = (T*)a0;
    n_max = N0;    
  }
  
  inline Array() {
    init_n++;
    init();
  }

#if 0  
  void alloc(sint4 i) {
    if (i <= 0) ERR("i<=0 in alloc");
    free();
    sint4 s = sizeof(T) * i;
    cout << "FOO " << s << endl;
    
    if (i > n_max) {
      n_max = i;
      a = (T*) malloc(s);
      cout << "FOO " << a << endl;      
    }
    if (!a) ERR("out of memory (Array::alloc)"); 
    alloc_n++;
    alloc_s += s;
    n = 0;
  }
#endif
  
  void push_back(T &x) {

    if (n >= n_max) {

      if (n_max == 0) {

	n_max = N0;
	a = (T*)a0;
	n = 0;

      } else {

#ifndef NDEBUG
	cout << "enlarge Array" << endl;
#endif	
	n_max += 2;
	n_max *= 3;
	n_max /= 2;
	sint4 s = sizeof(T) * n_max;
	T *p = (T*) ::malloc(s);
	if (!p) ERR("out of memory (Array::push_back)");
	memcpy(p, a, n * sizeof(T));
	free();
	a = p;
	alloc_n++;
	alloc_s += s;
      }
    }

    // cout << "a0=" << a0 << " a=" << a << " " << n << endl;
    a[n++] = x;
  }

  sint4 size() const { return n; }

  void set_size(sint4 i) {
    if (i > n_max) ERR("Array::set_size: i>n_max");
    if (i < 0) ERR("Array::set_size: i<0");    
    n = i;
  }
  
  T &operator [](sint4 i) {
#ifndef NDEBUG
    if (i < 0 || i >= n) ERR("out of bounds");
#endif
    return a[i];
  }
  const T &operator [](sint4 i) const {
#ifndef NDEBUG
    if (i < 0 || i >= n) ERR("out of bounds");
#endif
    return a[i];
  }  
  
  virtual ~Array() { free(); }
};

#endif

