/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* $Header$
   $Log$
   Revision 1.1  2004/10/11 09:09:18  orts_mburo
   Initial revision

   Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
   import

   Revision 1.2  2001/08/17 14:57:57  mic


   changed headers

*/

#ifndef Compress_H
#define Compress_H

#include "Global.H"

struct z_stream_s;

class Compress {

protected:

  static const uint4 N = 65536; // out_buffer size
  z_stream_s *pzs;
  sint1 *out_buffer;
  sint4 level;                  // compression level (max 9)
  
public:

  Compress(sint4 level_ = 9);
  virtual ~Compress();
  void init();  
  void init(sint4 level_);
  void doit(const std::string &input, std::string &output);
};


class Decompress {

protected:

  static const uint4 N = 65536;
  z_stream_s *pzs;
  sint1 *out_buffer;

public:

  Decompress();
  virtual ~Decompress();
  void init();
  bool doit(const std::string &input, std::string &output);
};


#endif
