/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header$
  $Log$
  Revision 1.1  2004/10/11 09:09:18  orts_mburo
  Initial revision

  Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
  import

*/

#ifndef Element_H
#define Element_H

#include "Global.H"
#include "MoveVars.H"
#include "Array.H"
#include "CompAction.H"
#include <set>

#define TEST 0

class Player;

typedef Array<sint4,300> NeighborInfo;


typedef set<sint4> PlayerSet;

class Element : public Prop {

public:

  Prop prev_prop;
  PlayerSet seen_by, prev_seen_by; // players who see this element

  // internal
  
  Pos    sv_target_pos;
  Pos    sv_fine_heading; // ceil(l2norm) = speed
  CompAction *comp_act;   // compute action class

  // temporary variables

  Prop opp_view;
  Prop prev_opp_view;

  vector<Prop> last_vicinity;
  Action       last_action;
  
  MoveVars  mv;
  bool      visited;
  NeighborInfo neighbors;
  
  Element() { comp_act = 0; }
  
  virtual ~Element();
};

#endif

