/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header$
*/

#ifndef ID_Factory_H
#define ID_Factory_H

#include "Global.H"
#include "String.H"
#include <set>

class ID_Factory {

protected:

  set<uint4> avail;
  
public:

  void ID_Factory::init(sint4 n)
  {
    assert(n > 1);
    for (sint4 i=1; i < n; i++) avail.insert(i);
  }

  ID_Factory::ID_Factory(sint4 n) { init(n); }

  uint4 ID_Factory::next()
  {
    if (avail.empty()) return 0;
    uint4 id = *avail.begin();
    avail.erase(avail.begin());

    // cout << "new ID= " << id << endl;
    return id;
  }

  bool ID_Factory::free(uint4 id)
  {
    if (id == 0) return true;
    if (avail.insert(id).second == false) return true;
    return false;
  }

  virtual ~ID_Factory() {};
};

#endif
