/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header$
  $Log$
  Revision 1.1  2004/10/11 09:09:18  orts_mburo
  Initial revision

  Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
  import

*/

#ifndef RT_ClientEnv_H
#define RT_ClientEnv_H

#include "Global.H"
#include "RT_Client.H"
#include "Compress.H"

class RTS_Game;
class ServerClient;
class RTS_Options;

class RT_ClientEnv {

private:

public:

  enum State { ST_IDLE, ST_CREATE, ST_RECV_OBJS, ST_COMP_ACTS, ST_SEND_ACTS };
  enum Event { EVT_NONE, EVT_STOP, EVT_NEW_OBJS };

  RTS_Options &opt;
  Compress compress;      // for actions
  Decompress decompress;  // for objects
  
  State state;
  RT_Client *rt_client;
  Event last_event;
  ServerClient *client;
  RTS_Game *game;
  bool local;  // true <=> create local views (-> vics)
  
  // temporary
  bool client_died;
  bool first_obj;

  string cpname; // client player name
  sint4  cpind;  // client player index
  vector<string> obj_msgs;
  
public:
	     
  vector<Prop> objs;
  vector< vector<Prop> > vics; // vicinities (CompAction interface)
  
  Event get_event();
  bool set_action(uint4 id, Action &act);
  void send_actions();

  RT_ClientEnv(RTS_Options &opt_);
  
  virtual ~RT_ClientEnv();

  void run();
};

#endif

