#


Name:      orts
Summary:   The Open Real-Time Strategy system.  
Version:   3
Release:   1
License:   GPL
Vendor:    Michael Buro <mburo@cs.ualberta.ca>
Packager:  Marc Lanctot <lanctot@cs.ualberta.ca>
Group:     Games
Source0:   http://www.cs.ualberta.ca/~mburo/orts/src_snapshot/orts.tgz
Source1:   http://www.cs.ualberta.ca/~mburo/orts/src_snapshot/orts_data.tgz
BuildRoot: /tmp/orts-buildroot
BuildRequires: gcc-c++ >= 3.4, libstdc++-devel, boost-devel >= 1.32, SDL-devel >= 1.2.7, SDL_net-devel >= 1.2.5, freeglut-devel, zlib-devel, glew-devel >= 1.3.2
Requires: boost >= 1.32, SDL >= 1.2.7, SDL_net >= 1.2.5, freeglut, zlib, glew, libstdc++
Prereq: /sbin/ldconfig
Prefix: /opt/orts

%description
ORTS is a programming environment for studying real-time AI problems such as pathfinding, 
dealing with imperfect information, scheduling, and planning in the domain of RTS games. 

For the most up-to-date information and sources please
visit the project web-site at http://www.cs.ualberta.ca/~mburo/orts/orts.html . 

%prep
rm -rf $RPM_BUILD_DIR/orts
rm -rf $RPM_BUILD_DIR/orts_data
[ %buildroot%prefix != "/" ] && rm -rf %buildroot%prefix
zcat $RPM_SOURCE_DIR/orts.tgz | tar -xvf -
zcat $RPM_SOURCE_DIR/orts_data.tgz | tar -xvf -
cd orts/trunk
echo Building ORTS
OSTYPE="LINUX" make init
OSTYPE="LINUX" make clean
cd libs/pathfinding/dcdt
./makelinks
cd ../../..

#%setup -q -n %{name}2-%{version}

%build
cd orts/trunk
OSTYPE="LINUX" make -j2 MODE=opt

%install
#we don't have a make install so...
#make DESTDIR=%buildroot install
mkdir -p %buildroot%prefix/bin
cp orts/trunk/bin/orts %buildroot%prefix/bin
cp orts/trunk/bin/ortsg %buildroot%prefix/bin
#cp -r orts/trunk/testgame %buildroot%prefix
cp -r orts/trunk/ortsg_std %buildroot%prefix
cp -r orts/trunk/games %buildroot%prefix
# all these are for orts-devel
cp -r orts/trunk/* %buildroot%prefix
#mkdir -p %buildroot%prefix/orts_data
cp -r orts_data/trunk %buildroot%prefix/orts_data
mkdir -p %buildroot/usr/local/bin
cd %buildroot/usr/local/bin
#ln -sf ../../..%prefix/bin/orts .
echo "#!/bin/sh" > orts
echo "%prefix/bin/orts -game3 -bp %prefix/games/game3.bp -x 64 -y 64 -fplat 0.08 -nplayers 2 \$@" >> orts
chmod a+rx orts
#ln -sf ../../..%prefix/bin/ortsg .
echo "#!/bin/sh" > ortsg
echo "%prefix/bin/ortsg -p %prefix/games/ortsg -gfx %prefix/orts_data -refresh 0 \$@" >> ortsg
chmod a+rx ortsg

%clean
[ ${RPM_BUILD_ROOT} != "/" ] && rm -rf ${RPM_BUILD_ROOT}

#%post
#cd %_docdir/HTML/*/%{name}2
#ln -s ../common common
#/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(755,root,root)
/usr/local/bin/orts
/usr/local/bin/ortsg
%prefix/bin/orts
%prefix/bin/ortsg
#%prefix/testgame
%prefix/ortsg_std
%prefix/games

#%dir %_docdir/HTML/en/%{name}2/
#%doc %_docdir/HTML/*/%{name}2/*.docbook
#%doc %_docdir/HTML/*/%{name}2/*.png
#%doc %_docdir/HTML/*/%{name}2/index.cache.bz2

# the binary files
#%{_bindir}/%{name}
#%{_bindir}/%{name}2


%package devel
#Requires:
Summary: ORTS development files
Group: Games 
Provides: orts-devel

%description devel
This package contains necessary header and source files for ORTS development.

%files devel
# everything (except orts_data)
%prefix/apps
%prefix/bin
%prefix/cfile
%prefix/config
%prefix/countlines
%prefix/dep
%prefix/docs
%prefix/games
%prefix/libs
%prefix/makefile
%prefix/makefile.mak
%prefix/misc
%prefix/obj
%prefix/ortsg_std
%prefix/ortsg.vcproj
%prefix/orts.sln
%prefix/orts_std_todo_list.txt
%prefix/orts.vcproj
%prefix/README
%prefix/rtscomp07.game1.uofa.vcproj
%prefix/rtscomp07.game2.uofa.vcproj
%prefix/rtscomp07.game3.uofa.vcproj
%prefix/scripts
#%prefix/Service_database.db
%prefix/testgame
%prefix/tournament-2006
%prefix/tournament-2007
%prefix/tourtest-2006


%package data
Summary: ORTS data files
Group: Games
Provides: orts_data

%description data
This package contains the necessary bitmaps and models needed for the graphical client. 

%files data
%defattr(755,root,root)
%prefix/orts_data

%changelog
* Fri Jun 15 2007 - lanctot@cs.ualberta.ca
- First created

