#!/bin/sh

dir=`pwd`
top=`basename $dir`

if [ "$top" != "orts" ]
then
   echo "Please run from orts3 directory. eg. misc/uncrustify/command"
   echo ""
   exit
fi

prefix=$1
if [ "$prefix" = "" ]
then
   echo "No prefix, using entire source tree"
   prefix="."
else
   if [ ! -d $prefix ]
   then
      echo "Prefix problem... directory not found, doesn't exist?"
      exit
   fi
fi

echo "Finding header files ... "
headerfiles=`find $prefix | egrep ".H$"`

echo "Finding source files ... "
sourcefiles=`find $prefix | egrep ".C$"`

files="$headerfiles $sourcefiles"

for f in $files
do
   echo "Uncristifying file $f ..."
   uncrustify -c misc/uncrustify/uncrustify.cfg --replace $f 2>/dev/null
done

