varying vec2 coord_shadow; uniform sampler2D shadow;

uniform sampler3D ntex;

varying vec4 dmult;
varying vec3 normal, lightDir, halfVector;
varying vec4 pos;

void main() {

        vec3 n, halfV, viewV, ldir;
        float NdotL, NdotHV;

        vec3 color = vec3(0.1, 0.1, 0.1); // ambient;
        vec4 diffuse = vec4(0.2, 0.5, 0.0, 1.0);

        mat3 myrot = mat3(0.7, 0.1, 0.7,
                          0.1, 1.0, 0.1,
                         -0.7, 0.1, 0.7);

        vec3 p1 = pos.xyz;
        vec3 p2 = myrot * pos.xyz;
        vec3 p3 = pos.xyz;

        vec3 c1 = texture3D(ntex, p1 * 1.60);
        vec3 c2 = texture3D(ntex, p2 * 0.17);
        vec3 c3 = texture3D(ntex, p3 * 0.06);

        diffuse.rgb += pow(0.7 * (c1 + c2), 4) * vec3(0.0, 1.0, 0.0) * 0.2;
        diffuse.g += (c2 * 0.05) + (c3 * 0.05);
        diffuse.rgb += (c1 * 0.1);

        float m = min(pow(0.7 * (c2 + c3), 16), 0.5);
//        diffuse.rgb = mix(diffuse.rgb, vec3(0.7, 0.9, 0.3), m.x);
        diffuse.rgb = mix(diffuse.rgb, vec3(0.5, 0.4, 0.1), m.x);

        diffuse *= dmult;

        n = normalize(normal);
        NdotL = max(dot(n, lightDir), 0.5);
        NdotL = mix(NdotL, 1.0, 0.5);

        if (NdotL > 0.0) {
                color.rgb += diffuse * NdotL;
                halfV = normalize(halfVector);
                NdotHV = max(dot(n, halfV), 0.0);
//                color += 0.1 * vec3(0.1, 0.07, 0.02) * pow(NdotHV, 32.0); // specular shininess
        }

        vec4 texel = texture2D(shadow, coord_shadow);
        float a = texel.a;
        gl_FragColor.rgb = mix(color.rgb, texel.rgb, a);
        gl_FragColor.a = 1.0;
}
