varying vec2 coord_shadow; uniform sampler2D shadow;

uniform sampler3D ntex;
uniform float anim;

varying vec4 dmult;
varying vec3 normal, lightDir, halfVector;
varying vec4 pos;

void main() {

        vec3 n, halfV, viewV, ldir;
        float NdotL, NdotHV;

        vec3 color = vec3(0.2, 0.3, 0.7); // ambient;
        vec4 diffuse = vec4(0.1, 0.1, 0.7, 1.0);

        mat3 myrot = mat3(0.7, 0.1, 0.7,
                          0.1, 1.0, 0.1,
                         -0.7, 0.3, 0.7);

        mat3 mrot2 = mat3(-0.7, 0.25, 0.7,
                          0.3, 1.0, 0.1,
                         -0.4, 0.2, -0.7);

        mat3 mrot3 = mat3(0.7, 0.5, 0.7,
                          0.1, 1.0, -0.3,
                         -0.5, 0.3, 0.7);

        pos.y += anim * 0.5;

        vec3 p1 = myrot * pos.xyz;
        vec3 p2 = mrot2 * pos.xyz;
        vec3 p3 = mrot3 * pos.xyz;

        vec3 c1 = texture3D(ntex, p1 * 0.71) * 2.0 - 1.0;
        vec3 c2 = texture3D(ntex, p2 * 0.17) * 2.0 - 1.0;
        vec3 c3 = texture3D(ntex, p3 * 0.06) * 2.0 - 1.0;

//        diffuse.rgb += pow(0.7 * (c1 + c2), 4) * vec3(0.0, 1.0, 0.0) * 0.2;
        diffuse.b += (c2.x * 0.05) + (c3.x * 0.05);
        diffuse.rgb += (c1 * 0.1);

//        diffuse *= dmult;

        n = normalize(normal) + c1 * 0.4 + c2 * 0.4;

        NdotL = max(dot(n, lightDir), 0.0);
        NdotL = mix(NdotL, 1.0, 0.5);

        vec4 spec;

        // specular shininess
        if (NdotL > 0.0) {
                color.rgb += diffuse * NdotL;
                halfV = normalize(halfVector) + c3 * 0.2 + c2 * 0.2;
                NdotHV = max(dot(n, halfV), 0.0);
                spec = 0.1 * vec4(0.1, 0.1, 0.1, 0.05) * pow(NdotHV, 6.0);
        }

        vec4 texel = texture2D(shadow, coord_shadow);
        float a = texel.a;
        gl_FragColor.rgb = mix(color.rgb, texel.rgb, a);
        gl_FragColor.rgb = color.rgb;
        gl_FragColor.a = 0.2;

        gl_FragColor += spec;
}
