#!/bin/bash
if [ -z "$1" ]
then
  echo ' '
  echo 'syntax:'
  echo '  run_tourney.sh <number of games> <out file>'
  echo ' '
  echo 'example:'
  echo '  run_tourney.sh 100 tourney.log'
  echo ' '
  exit
fi

NUM_GAMES=$1
RESULTS=$2
P1='-ai random'
P2='-ai flag'
P3='-ai mc -mcruns 3 -mcsteps 3'
P4='-ai mc -mcruns 10 -mcsteps 10'
P5='-ai mc -mcruns 30 -mcsteps 30'
mv $RESULTS $RESULTS.old
echo "---" 1> $RESULTS
echo "Start Time: " 1>> $RESULTS
date 1>> $RESULTS
echo "---" 1>> $RESULTS
echo "Tourney results:" 1>> $RESULTS
echo "---" 1>> $RESULTS
./run_match.sh $NUM_GAMES "$P1" "$P2" 1>> $RESULTS
./run_match.sh $NUM_GAMES "$P1" "$P3" 1>> $RESULTS
./run_match.sh $NUM_GAMES "$P2" "$P3" 1>> $RESULTS
./run_match.sh $NUM_GAMES "$P3" "$P4" 1>> $RESULTS
./run_match.sh $NUM_GAMES "$P3" "$P5" 1>> $RESULTS
./run_match.sh $NUM_GAMES "$P4" "$P5" 1>> $RESULTS
echo "---" 1>> $RESULTS
echo "End Time: " 1>> $RESULTS
echo "---" 1>> $RESULTS
date 1>> $RESULTS
cat $RESULTS
